/* MainWindow.c generated by valac 0.56.14, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*-
 * Copyright 2018-2022 elementary, Inc. (https://elementary.io)
 *           2014 Marvin Beckers <beckersmarvin@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Marvin Beckers <beckersmarvin@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite-7.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <langinfo.h>

#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX "win."
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_CLEAR "action-clear"
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT "action-insert"
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION "action-function"
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_UNDO "action-undo"
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_COPY "action-copy"
#define PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PASTE "action-paste"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW (pantheon_calculator_main_window_get_type ())
#define PANTHEON_CALCULATOR_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, PantheonCalculatorMainWindow))
#define PANTHEON_CALCULATOR_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, PantheonCalculatorMainWindowClass))
#define PANTHEON_CALCULATOR_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW))
#define PANTHEON_CALCULATOR_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW))
#define PANTHEON_CALCULATOR_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, PantheonCalculatorMainWindowClass))

typedef struct _PantheonCalculatorMainWindow PantheonCalculatorMainWindow;
typedef struct _PantheonCalculatorMainWindowClass PantheonCalculatorMainWindowClass;
typedef struct _PantheonCalculatorMainWindowPrivate PantheonCalculatorMainWindowPrivate;

#define PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG (pantheon_calculator_history_dialog_get_type ())
#define PANTHEON_CALCULATOR_HISTORY_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG, PantheonCalculatorHistoryDialog))
#define PANTHEON_CALCULATOR_HISTORY_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG, PantheonCalculatorHistoryDialogClass))
#define PANTHEON_CALCULATOR_IS_HISTORY_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG))
#define PANTHEON_CALCULATOR_IS_HISTORY_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG))
#define PANTHEON_CALCULATOR_HISTORY_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_CALCULATOR_TYPE_HISTORY_DIALOG, PantheonCalculatorHistoryDialogClass))

typedef struct _PantheonCalculatorHistoryDialog PantheonCalculatorHistoryDialog;
typedef struct _PantheonCalculatorHistoryDialogClass PantheonCalculatorHistoryDialogClass;

#define PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION (pantheon_calculator_core_evaluation_get_type ())
#define PANTHEON_CALCULATOR_CORE_EVALUATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION, PantheonCalculatorCoreEvaluation))
#define PANTHEON_CALCULATOR_CORE_EVALUATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION, PantheonCalculatorCoreEvaluationClass))
#define PANTHEON_CALCULATOR_CORE_IS_EVALUATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION))
#define PANTHEON_CALCULATOR_CORE_IS_EVALUATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION))
#define PANTHEON_CALCULATOR_CORE_EVALUATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_CALCULATOR_CORE_TYPE_EVALUATION, PantheonCalculatorCoreEvaluationClass))

typedef struct _PantheonCalculatorCoreEvaluation PantheonCalculatorCoreEvaluation;
typedef struct _PantheonCalculatorCoreEvaluationClass PantheonCalculatorCoreEvaluationClass;

#define PANTHEON_CALCULATOR_MAIN_WINDOW_TYPE_HISTORY (pantheon_calculator_main_window_history_get_type ())
typedef struct _PantheonCalculatorMainWindowHistory PantheonCalculatorMainWindowHistory;
enum  {
	PANTHEON_CALCULATOR_MAIN_WINDOW_0_PROPERTY,
	PANTHEON_CALCULATOR_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* pantheon_calculator_main_window_properties[PANTHEON_CALCULATOR_MAIN_WINDOW_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PantheonCalculatorMainWindowGetClipboardTextData PantheonCalculatorMainWindowGetClipboardTextData;

#define PANTHEON_CALCULATOR_CORE_TYPE_OUT_ERROR (pantheon_calculator_core_out_error_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _PantheonCalculatorCoreEvaluationPrivate PantheonCalculatorCoreEvaluationPrivate;

#define PANTHEON_CALCULATOR_CORE_TYPE_SCANNER (pantheon_calculator_core_scanner_get_type ())
#define PANTHEON_CALCULATOR_CORE_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_CALCULATOR_CORE_TYPE_SCANNER, PantheonCalculatorCoreScanner))
#define PANTHEON_CALCULATOR_CORE_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_CALCULATOR_CORE_TYPE_SCANNER, PantheonCalculatorCoreScannerClass))
#define PANTHEON_CALCULATOR_CORE_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_CALCULATOR_CORE_TYPE_SCANNER))
#define PANTHEON_CALCULATOR_CORE_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_CALCULATOR_CORE_TYPE_SCANNER))
#define PANTHEON_CALCULATOR_CORE_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_CALCULATOR_CORE_TYPE_SCANNER, PantheonCalculatorCoreScannerClass))

typedef struct _PantheonCalculatorCoreScanner PantheonCalculatorCoreScanner;
typedef struct _PantheonCalculatorCoreScannerClass PantheonCalculatorCoreScannerClass;
typedef struct _Block2Data Block2Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define PANTHEON_CALCULATOR_TYPE_BUTTON (pantheon_calculator_button_get_type ())
#define PANTHEON_CALCULATOR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_CALCULATOR_TYPE_BUTTON, PantheonCalculatorButton))
#define PANTHEON_CALCULATOR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_CALCULATOR_TYPE_BUTTON, PantheonCalculatorButtonClass))
#define PANTHEON_CALCULATOR_IS_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_CALCULATOR_TYPE_BUTTON))
#define PANTHEON_CALCULATOR_IS_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_CALCULATOR_TYPE_BUTTON))
#define PANTHEON_CALCULATOR_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_CALCULATOR_TYPE_BUTTON, PantheonCalculatorButtonClass))

typedef struct _PantheonCalculatorButton PantheonCalculatorButton;
typedef struct _PantheonCalculatorButtonClass PantheonCalculatorButtonClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PantheonCalculatorMainWindow {
	GtkApplicationWindow parent_instance;
	PantheonCalculatorMainWindowPrivate * priv;
};

struct _PantheonCalculatorMainWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _PantheonCalculatorMainWindowHistory {
	gchar* exp;
	gchar* output;
};

struct _PantheonCalculatorMainWindowPrivate {
	GtkRevealer* extended_revealer;
	GtkEntry* entry;
	GtkButton* button_calc;
	GtkButton* button_history;
	GtkButton* button_ans;
	GtkButton* button_del;
	GtkButton* button_mr;
	GtkButton* button_mc;
	GtkButton* button_gt;
	GtkToggleButton* button_extended;
	PantheonCalculatorHistoryDialog* history_dialog;
	GtkInfoBar* infobar;
	GtkLabel* infobar_label;
	PantheonCalculatorCoreEvaluation* eval;
	GList* history;
	gint position;
	gint decimal_places;
	gdouble memory_value;
};

struct _PantheonCalculatorMainWindowGetClipboardTextData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PantheonCalculatorMainWindow* self;
	gchar* result;
	gchar* _tmp0_;
	GtkEntry* _tmp1_;
	GdkClipboard* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

typedef enum  {
	PANTHEON_CALCULATOR_CORE_OUT_ERROR_EVAL_ERROR,
	PANTHEON_CALCULATOR_CORE_OUT_ERROR_CHECK_ERROR,
	PANTHEON_CALCULATOR_CORE_OUT_ERROR_SHUNTING_ERROR,
	PANTHEON_CALCULATOR_CORE_OUT_ERROR_SCANNER_ERROR
} PantheonCalculatorCoreOUT_ERROR;
#define PANTHEON_CALCULATOR_CORE_OUT_ERROR pantheon_calculator_core_out_error_quark ()

struct _PantheonCalculatorCoreEvaluation {
	GObject parent_instance;
	PantheonCalculatorCoreEvaluationPrivate * priv;
	PantheonCalculatorCoreScanner* scanner;
};

struct _PantheonCalculatorCoreEvaluationClass {
	GObjectClass parent_class;
};

struct _Block2Data {
	int _ref_count_;
	PantheonCalculatorMainWindow* self;
	gdouble grand_total;
};

static gint PantheonCalculatorMainWindow_private_offset;
static gpointer pantheon_calculator_main_window_parent_class = NULL;
static GSettings* pantheon_calculator_main_window_settings;
static GSettings* pantheon_calculator_main_window_settings = NULL;

VALA_EXTERN GType pantheon_calculator_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PantheonCalculatorMainWindow, g_object_unref)
VALA_EXTERN GType pantheon_calculator_history_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PantheonCalculatorHistoryDialog, g_object_unref)
VALA_EXTERN GType pantheon_calculator_core_evaluation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PantheonCalculatorCoreEvaluation, g_object_unref)
VALA_EXTERN GType pantheon_calculator_main_window_history_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PantheonCalculatorMainWindowHistory* pantheon_calculator_main_window_history_dup (const PantheonCalculatorMainWindowHistory* self);
VALA_EXTERN void pantheon_calculator_main_window_history_free (PantheonCalculatorMainWindowHistory* self);
VALA_EXTERN void pantheon_calculator_main_window_history_copy (const PantheonCalculatorMainWindowHistory* self,
                                                   PantheonCalculatorMainWindowHistory* dest);
VALA_EXTERN void pantheon_calculator_main_window_history_destroy (PantheonCalculatorMainWindowHistory* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (PantheonCalculatorMainWindowHistory, pantheon_calculator_main_window_history_destroy)
static void pantheon_calculator_main_window_action_insert (PantheonCalculatorMainWindow* self,
                                                    GSimpleAction* action,
                                                    GVariant* variant);
static void _pantheon_calculator_main_window_action_insert_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void pantheon_calculator_main_window_action_function (PantheonCalculatorMainWindow* self,
                                                      GSimpleAction* action,
                                                      GVariant* variant);
static void _pantheon_calculator_main_window_action_function_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void pantheon_calculator_main_window_action_clear (PantheonCalculatorMainWindow* self);
static void _pantheon_calculator_main_window_action_clear_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void pantheon_calculator_main_window_undo (PantheonCalculatorMainWindow* self);
static void _pantheon_calculator_main_window_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void pantheon_calculator_main_window_copy (PantheonCalculatorMainWindow* self);
static void _pantheon_calculator_main_window_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void pantheon_calculator_main_window_paste (PantheonCalculatorMainWindow* self);
static void _pantheon_calculator_main_window_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void _pantheon_calculator_main_window_history_free0_ (gpointer var);
static inline void _g_list_free__pantheon_calculator_main_window_history_free0_ (GList* self);
VALA_EXTERN PantheonCalculatorMainWindow* pantheon_calculator_main_window_new (GtkApplication* application);
VALA_EXTERN PantheonCalculatorMainWindow* pantheon_calculator_main_window_construct (GType object_type,
                                                                         GtkApplication* application);
static void pantheon_calculator_main_window_get_clipboard_text (PantheonCalculatorMainWindow* self,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
static gchar* pantheon_calculator_main_window_get_clipboard_text_finish (PantheonCalculatorMainWindow* self,
                                                                  GAsyncResult* _res_);
static void __lambda33_ (PantheonCalculatorMainWindow* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda33__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void pantheon_calculator_main_window_get_clipboard_text_data_free (gpointer _data);
static gboolean pantheon_calculator_main_window_get_clipboard_text_co (PantheonCalculatorMainWindowGetClipboardTextData* _data_);
static void pantheon_calculator_main_window_get_clipboard_text_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static void pantheon_calculator_main_window_button_calc_clicked (PantheonCalculatorMainWindow* self);
VALA_EXTERN GQuark pantheon_calculator_core_out_error_quark (void);
VALA_EXTERN GType pantheon_calculator_core_out_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* pantheon_calculator_core_evaluation_evaluate (PantheonCalculatorCoreEvaluation* self,
                                                     const gchar* str,
                                                     gint d_places,
                                                     GError** error);
static void pantheon_calculator_main_window_update_history_dialog (PantheonCalculatorMainWindow* self,
                                                            PantheonCalculatorMainWindowHistory* entry);
static void pantheon_calculator_main_window_remove_error (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_reciprocal_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_del_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_memory_store_clicked (PantheonCalculatorMainWindow* self);
VALA_EXTERN GType pantheon_calculator_core_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PantheonCalculatorCoreScanner, g_object_unref)
VALA_EXTERN const gchar* pantheon_calculator_core_scanner_get_decimal_symbol (PantheonCalculatorCoreScanner* self);
static void pantheon_calculator_main_window_button_memory_add_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_memory_subtract_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_memory_clear_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_button_gt_clicked (PantheonCalculatorMainWindow* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda34_ (Block2Data* _data2_,
                  PantheonCalculatorMainWindowHistory* list_entry);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
static gchar* pantheon_calculator_main_window_number_to_string (PantheonCalculatorMainWindow* self,
                                                         gdouble number);
VALA_EXTERN const gchar* pantheon_calculator_core_scanner_get_separator_symbol (PantheonCalculatorCoreScanner* self);
static void pantheon_calculator_main_window_button_ans_clicked (PantheonCalculatorMainWindow* self);
static void pantheon_calculator_main_window_history_added (PantheonCalculatorMainWindow* self,
                                                    const gchar* input);
static void pantheon_calculator_main_window_toggle_grid (PantheonCalculatorMainWindow* self,
                                                  GtkToggleButton* button);
static void pantheon_calculator_main_window_show_history (PantheonCalculatorMainWindow* self,
                                                   GtkButton* button);
VALA_EXTERN PantheonCalculatorHistoryDialog* pantheon_calculator_history_dialog_new (GList* _history);
VALA_EXTERN PantheonCalculatorHistoryDialog* pantheon_calculator_history_dialog_construct (GType object_type,
                                                                               GList* _history);
static void _pantheon_calculator_main_window_history_added_pantheon_calculator_history_dialog_added (PantheonCalculatorHistoryDialog* _sender,
                                                                                              const gchar* text,
                                                                                              gpointer self);
static void __lambda35_ (PantheonCalculatorMainWindow* self);
static void __lambda36_ (PantheonCalculatorMainWindow* self,
                  PantheonCalculatorMainWindowHistory* entry);
static void ___lambda36__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda35__pantheon_calculator_history_dialog_clear_history (PantheonCalculatorHistoryDialog* _sender,
                                                                    gpointer self);
static void __lambda37_ (PantheonCalculatorMainWindow* self);
static void ___lambda37__gtk_widget_hide (GtkWidget* _sender,
                                   gpointer self);
VALA_EXTERN void pantheon_calculator_history_dialog_append (PantheonCalculatorHistoryDialog* self,
                                                PantheonCalculatorMainWindowHistory* entry);
static void pantheon_calculator_main_window_replace_text (PantheonCalculatorMainWindow* self,
                                                   const gchar* new_text,
                                                   gint new_text_length,
                                                   gint* position);
static GObject * pantheon_calculator_main_window_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
VALA_EXTERN PantheonCalculatorCoreEvaluation* pantheon_calculator_core_evaluation_new (void);
VALA_EXTERN PantheonCalculatorCoreEvaluation* pantheon_calculator_core_evaluation_construct (GType object_type);
static void _pantheon_calculator_main_window_toggle_grid_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                             gpointer self);
static void _pantheon_calculator_main_window_show_history_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
VALA_EXTERN GType pantheon_calculator_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PantheonCalculatorButton, g_object_unref)
VALA_EXTERN PantheonCalculatorButton* pantheon_calculator_button_new (const gchar* label);
VALA_EXTERN PantheonCalculatorButton* pantheon_calculator_button_construct (GType object_type,
                                                                const gchar* label);
static void _pantheon_calculator_main_window_remove_error_gtk_editable_changed (GtkEditable* _sender,
                                                                         gpointer self);
static void _pantheon_calculator_main_window_button_calc_clicked_gtk_entry_activate (GtkEntry* _sender,
                                                                              gpointer self);
static void _pantheon_calculator_main_window_replace_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                             const gchar* text,
                                                                             gint length,
                                                                             gint* position,
                                                                             gpointer self);
static void _pantheon_calculator_main_window___lambda38_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda38__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda39_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda39__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda40_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda40__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda41_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda41__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda42_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda42__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda43_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda43__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda44_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda44__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda45_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda45__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda46_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda46__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _pantheon_calculator_main_window___lambda47_ (PantheonCalculatorMainWindow* self);
static void __pantheon_calculator_main_window___lambda47__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void pantheon_calculator_main_window_finalize (GObject * obj);
static GType pantheon_calculator_main_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_ENTRIES[6] = {{PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT, _pantheon_calculator_main_window_action_insert_gsimple_action_activate_callback, "s"}, {PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION, _pantheon_calculator_main_window_action_function_gsimple_action_activate_callback, "s"}, {PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_CLEAR, _pantheon_calculator_main_window_action_clear_gsimple_action_activate_callback}, {PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_UNDO, _pantheon_calculator_main_window_undo_gsimple_action_activate_callback}, {PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_COPY, _pantheon_calculator_main_window_copy_gsimple_action_activate_callback}, {PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PASTE, _pantheon_calculator_main_window_paste_gsimple_action_activate_callback}};

static inline gpointer
pantheon_calculator_main_window_get_instance_private (PantheonCalculatorMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonCalculatorMainWindow_private_offset);
}

static void
_pantheon_calculator_main_window_action_insert_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_action_insert ((PantheonCalculatorMainWindow*) self, action, parameter);
#line 406 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_action_function_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_action_function ((PantheonCalculatorMainWindow*) self, action, parameter);
#line 416 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_action_clear_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_action_clear ((PantheonCalculatorMainWindow*) self);
#line 426 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_undo ((PantheonCalculatorMainWindow*) self);
#line 436 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_copy ((PantheonCalculatorMainWindow*) self);
#line 446 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 58 "../src/MainWindow.vala"
	pantheon_calculator_main_window_paste ((PantheonCalculatorMainWindow*) self);
#line 456 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_history_free0_ (gpointer var)
{
#line 41 "../src/MainWindow.vala"
	(var == NULL) ? NULL : (var = (pantheon_calculator_main_window_history_free (var), NULL));
#line 464 "MainWindow.c"
}

static inline void
_g_list_free__pantheon_calculator_main_window_history_free0_ (GList* self)
{
#line 41 "../src/MainWindow.vala"
	g_list_free_full (self, (GDestroyNotify) _pantheon_calculator_main_window_history_free0_);
#line 472 "MainWindow.c"
}

PantheonCalculatorMainWindow*
pantheon_calculator_main_window_construct (GType object_type,
                                           GtkApplication* application)
{
	PantheonCalculatorMainWindow * self = NULL;
#line 71 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 72 "../src/MainWindow.vala"
	self = (PantheonCalculatorMainWindow*) g_object_new (object_type, "application", application, NULL);
#line 71 "../src/MainWindow.vala"
	return self;
#line 486 "MainWindow.c"
}

PantheonCalculatorMainWindow*
pantheon_calculator_main_window_new (GtkApplication* application)
{
#line 71 "../src/MainWindow.vala"
	return pantheon_calculator_main_window_construct (PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, application);
#line 494 "MainWindow.c"
}

static void
pantheon_calculator_main_window_undo (PantheonCalculatorMainWindow* self)
{
	GList* previous_entry = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 504 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 505 "../src/MainWindow.vala"
	_tmp0_ = self->priv->history;
#line 505 "../src/MainWindow.vala"
	_tmp1_ = g_list_last (_tmp0_);
#line 505 "../src/MainWindow.vala"
	previous_entry = _tmp1_;
#line 506 "../src/MainWindow.vala"
	_tmp2_ = previous_entry;
#line 506 "../src/MainWindow.vala"
	if (_tmp2_ != NULL) {
#line 516 "MainWindow.c"
		GtkEntry* _tmp3_;
		GList* _tmp4_;
		gconstpointer _tmp5_;
		const gchar* _tmp6_;
		GList* _tmp7_;
#line 507 "../src/MainWindow.vala"
		_tmp3_ = self->priv->entry;
#line 507 "../src/MainWindow.vala"
		_tmp4_ = previous_entry;
#line 507 "../src/MainWindow.vala"
		_tmp5_ = _tmp4_->data;
#line 507 "../src/MainWindow.vala"
		_tmp6_ = (*((PantheonCalculatorMainWindowHistory*) _tmp5_)).exp;
#line 507 "../src/MainWindow.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp3_, _tmp6_);
#line 508 "../src/MainWindow.vala"
		_tmp7_ = previous_entry;
#line 508 "../src/MainWindow.vala"
		self->priv->history = g_list_remove_link (self->priv->history, _tmp7_);
#line 536 "MainWindow.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 564 "MainWindow.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 570 "MainWindow.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 576 "MainWindow.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 580 "MainWindow.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 588 "MainWindow.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 592 "MainWindow.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 604 "MainWindow.c"
}

static void
pantheon_calculator_main_window_copy (PantheonCalculatorMainWindow* self)
{
	gint start = 0;
	gint end = 0;
	GtkEntry* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean text_selected = FALSE;
#line 512 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 514 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 514 "../src/MainWindow.vala"
	gtk_editable_get_selection_bounds ((GtkEditable*) _tmp0_, &_tmp1_, &_tmp2_);
#line 514 "../src/MainWindow.vala"
	start = _tmp1_;
#line 514 "../src/MainWindow.vala"
	end = _tmp2_;
#line 515 "../src/MainWindow.vala"
	text_selected = (end - start) != 0;
#line 519 "../src/MainWindow.vala"
	if (!text_selected) {
#line 630 "MainWindow.c"
		GtkEntry* _tmp3_;
		GdkClipboard* _tmp4_;
		GtkEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 520 "../src/MainWindow.vala"
		_tmp3_ = self->priv->entry;
#line 520 "../src/MainWindow.vala"
		_tmp4_ = gtk_widget_get_clipboard ((GtkWidget*) _tmp3_);
#line 520 "../src/MainWindow.vala"
		_tmp5_ = self->priv->entry;
#line 520 "../src/MainWindow.vala"
		_tmp6_ = gtk_editable_get_text ((GtkEditable*) _tmp5_);
#line 520 "../src/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 520 "../src/MainWindow.vala"
		gdk_clipboard_set_text (_tmp4_, _tmp7_);
#line 648 "MainWindow.c"
	} else {
		GtkEntry* _tmp8_;
		GdkClipboard* _tmp9_;
		GtkEntry* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 522 "../src/MainWindow.vala"
		_tmp8_ = self->priv->entry;
#line 522 "../src/MainWindow.vala"
		_tmp9_ = gtk_widget_get_clipboard ((GtkWidget*) _tmp8_);
#line 522 "../src/MainWindow.vala"
		_tmp10_ = self->priv->entry;
#line 522 "../src/MainWindow.vala"
		_tmp11_ = gtk_editable_get_text ((GtkEditable*) _tmp10_);
#line 522 "../src/MainWindow.vala"
		_tmp12_ = _tmp11_;
#line 522 "../src/MainWindow.vala"
		_tmp13_ = string_slice (_tmp12_, (glong) start, (glong) end);
#line 522 "../src/MainWindow.vala"
		_tmp14_ = _tmp13_;
#line 522 "../src/MainWindow.vala"
		gdk_clipboard_set_text (_tmp9_, _tmp14_);
#line 522 "../src/MainWindow.vala"
		_g_free0 (_tmp14_);
#line 675 "MainWindow.c"
	}
}

static void
__lambda33_ (PantheonCalculatorMainWindow* self,
             GObject* obj,
             GAsyncResult* res)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint start = 0;
	gint end = 0;
	GtkEntry* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* before = NULL;
	GtkEntry* _tmp5_;
	gchar* _tmp6_;
	gchar* after = NULL;
	GtkEntry* _tmp7_;
	gchar* _tmp8_;
	GtkEntry* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkEntry* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
#line 527 "../src/MainWindow.vala"
	g_return_if_fail (res != NULL);
#line 528 "../src/MainWindow.vala"
	_tmp0_ = pantheon_calculator_main_window_get_clipboard_text_finish (self, res);
#line 528 "../src/MainWindow.vala"
	text = _tmp0_;
#line 529 "../src/MainWindow.vala"
	_tmp1_ = text;
#line 529 "../src/MainWindow.vala"
	if (_tmp1_ == NULL) {
#line 530 "../src/MainWindow.vala"
		_g_free0 (text);
#line 530 "../src/MainWindow.vala"
		return;
#line 723 "MainWindow.c"
	}
#line 534 "../src/MainWindow.vala"
	_tmp2_ = self->priv->entry;
#line 534 "../src/MainWindow.vala"
	gtk_editable_get_selection_bounds ((GtkEditable*) _tmp2_, &_tmp3_, &_tmp4_);
#line 534 "../src/MainWindow.vala"
	start = _tmp3_;
#line 534 "../src/MainWindow.vala"
	end = _tmp4_;
#line 536 "../src/MainWindow.vala"
	_tmp5_ = self->priv->entry;
#line 536 "../src/MainWindow.vala"
	_tmp6_ = gtk_editable_get_chars ((GtkEditable*) _tmp5_, 0, start);
#line 536 "../src/MainWindow.vala"
	before = _tmp6_;
#line 537 "../src/MainWindow.vala"
	_tmp7_ = self->priv->entry;
#line 537 "../src/MainWindow.vala"
	_tmp8_ = gtk_editable_get_chars ((GtkEditable*) _tmp7_, end, -1);
#line 537 "../src/MainWindow.vala"
	after = _tmp8_;
#line 538 "../src/MainWindow.vala"
	_tmp9_ = self->priv->entry;
#line 538 "../src/MainWindow.vala"
	_tmp10_ = before;
#line 538 "../src/MainWindow.vala"
	_tmp11_ = text;
#line 538 "../src/MainWindow.vala"
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 538 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 538 "../src/MainWindow.vala"
	_tmp14_ = after;
#line 538 "../src/MainWindow.vala"
	_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
#line 538 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 538 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp9_, _tmp16_);
#line 538 "../src/MainWindow.vala"
	_g_free0 (_tmp16_);
#line 538 "../src/MainWindow.vala"
	_g_free0 (_tmp13_);
#line 539 "../src/MainWindow.vala"
	_tmp17_ = self->priv->entry;
#line 539 "../src/MainWindow.vala"
	_tmp18_ = before;
#line 539 "../src/MainWindow.vala"
	_tmp19_ = text;
#line 539 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp17_, g_utf8_strlen (_tmp18_, (gssize) -1) + g_utf8_strlen (_tmp19_, (gssize) -1));
#line 527 "../src/MainWindow.vala"
	_g_free0 (after);
#line 527 "../src/MainWindow.vala"
	_g_free0 (before);
#line 527 "../src/MainWindow.vala"
	_g_free0 (text);
#line 781 "MainWindow.c"
}

static void
___lambda33__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 527 "../src/MainWindow.vala"
	__lambda33_ ((PantheonCalculatorMainWindow*) self, source_object, res);
#line 527 "../src/MainWindow.vala"
	g_object_unref (self);
#line 793 "MainWindow.c"
}

static void
pantheon_calculator_main_window_paste (PantheonCalculatorMainWindow* self)
{
#line 526 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 527 "../src/MainWindow.vala"
	pantheon_calculator_main_window_get_clipboard_text (self, ___lambda33__gasync_ready_callback, g_object_ref (self));
#line 803 "MainWindow.c"
}

static void
pantheon_calculator_main_window_get_clipboard_text_data_free (gpointer _data)
{
	PantheonCalculatorMainWindowGetClipboardTextData* _data_;
	_data_ = _data;
#line 21 "../src/MainWindow.vala"
	_g_free0 (_data_->result);
#line 21 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/MainWindow.vala"
	g_slice_free (PantheonCalculatorMainWindowGetClipboardTextData, _data_);
#line 817 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 825 "MainWindow.c"
}

static void
pantheon_calculator_main_window_get_clipboard_text (PantheonCalculatorMainWindow* self,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	PantheonCalculatorMainWindowGetClipboardTextData* _data_;
	PantheonCalculatorMainWindow* _tmp0_;
#line 21 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/MainWindow.vala"
	_data_ = g_slice_new0 (PantheonCalculatorMainWindowGetClipboardTextData);
#line 21 "../src/MainWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/MainWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, pantheon_calculator_main_window_get_clipboard_text_data_free);
#line 21 "../src/MainWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/MainWindow.vala"
	_data_->self = _tmp0_;
#line 21 "../src/MainWindow.vala"
	pantheon_calculator_main_window_get_clipboard_text_co (_data_);
#line 849 "MainWindow.c"
}

static gchar*
pantheon_calculator_main_window_get_clipboard_text_finish (PantheonCalculatorMainWindow* self,
                                                           GAsyncResult* _res_)
{
	gchar* result;
	PantheonCalculatorMainWindowGetClipboardTextData* _data_;
#line 21 "../src/MainWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 21 "../src/MainWindow.vala"
	result = _data_->result;
#line 21 "../src/MainWindow.vala"
	_data_->result = NULL;
#line 21 "../src/MainWindow.vala"
	return result;
#line 866 "MainWindow.c"
}

static void
pantheon_calculator_main_window_get_clipboard_text_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	PantheonCalculatorMainWindowGetClipboardTextData* _data_;
#line 545 "../src/MainWindow.vala"
	_data_ = _user_data_;
#line 545 "../src/MainWindow.vala"
	_data_->_source_object_ = source_object;
#line 545 "../src/MainWindow.vala"
	_data_->_res_ = _res_;
#line 545 "../src/MainWindow.vala"
	pantheon_calculator_main_window_get_clipboard_text_co (_data_);
#line 883 "MainWindow.c"
}

static gboolean
pantheon_calculator_main_window_get_clipboard_text_co (PantheonCalculatorMainWindowGetClipboardTextData* _data_)
{
#line 543 "../src/MainWindow.vala"
	switch (_data_->_state_) {
#line 543 "../src/MainWindow.vala"
		case 0:
#line 893 "MainWindow.c"
		goto _state_0;
#line 543 "../src/MainWindow.vala"
		case 1:
#line 897 "MainWindow.c"
		goto _state_1;
		default:
#line 543 "../src/MainWindow.vala"
		g_assert_not_reached ();
#line 902 "MainWindow.c"
	}
	_state_0:
	{
#line 545 "../src/MainWindow.vala"
		_data_->_tmp1_ = _data_->self->priv->entry;
#line 545 "../src/MainWindow.vala"
		_data_->_tmp2_ = gtk_widget_get_clipboard ((GtkWidget*) _data_->_tmp1_);
#line 545 "../src/MainWindow.vala"
		_data_->_state_ = 1;
#line 545 "../src/MainWindow.vala"
		gdk_clipboard_read_text_async (_data_->_tmp2_, NULL, pantheon_calculator_main_window_get_clipboard_text_ready, _data_);
#line 545 "../src/MainWindow.vala"
		return FALSE;
#line 916 "MainWindow.c"
		_state_1:
#line 545 "../src/MainWindow.vala"
		_data_->_tmp3_ = gdk_clipboard_read_text_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 545 "../src/MainWindow.vala"
		_data_->_tmp0_ = _data_->_tmp3_;
#line 545 "../src/MainWindow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 924 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 545 "../src/MainWindow.vala"
		_data_->_tmp4_ = _data_->_tmp0_;
#line 545 "../src/MainWindow.vala"
		_data_->_tmp0_ = NULL;
#line 545 "../src/MainWindow.vala"
		_data_->result = _data_->_tmp4_;
#line 545 "../src/MainWindow.vala"
		_g_free0 (_data_->_tmp0_);
#line 545 "../src/MainWindow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 545 "../src/MainWindow.vala"
		if (_data_->_state_ != 0) {
#line 545 "../src/MainWindow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 545 "../src/MainWindow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 943 "MainWindow.c"
			}
		}
#line 545 "../src/MainWindow.vala"
		g_object_unref (_data_->_async_result);
#line 545 "../src/MainWindow.vala"
		return FALSE;
#line 950 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 544 "../src/MainWindow.vala"
		_data_->e = _data_->_inner_error0_;
#line 544 "../src/MainWindow.vala"
		_data_->_inner_error0_ = NULL;
#line 547 "../src/MainWindow.vala"
		_data_->_tmp5_ = _data_->e;
#line 547 "../src/MainWindow.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 547 "../src/MainWindow.vala"
		g_warning ("MainWindow.vala:547: %s", _data_->_tmp6_);
#line 548 "../src/MainWindow.vala"
		_data_->result = NULL;
#line 548 "../src/MainWindow.vala"
		_g_error_free0 (_data_->e);
#line 548 "../src/MainWindow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 548 "../src/MainWindow.vala"
		if (_data_->_state_ != 0) {
#line 548 "../src/MainWindow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 548 "../src/MainWindow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 977 "MainWindow.c"
			}
		}
#line 548 "../src/MainWindow.vala"
		g_object_unref (_data_->_async_result);
#line 548 "../src/MainWindow.vala"
		return FALSE;
#line 984 "MainWindow.c"
	}
	__finally0:
#line 544 "../src/MainWindow.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 544 "../src/MainWindow.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 544 "../src/MainWindow.vala"
	g_object_unref (_data_->_async_result);
#line 544 "../src/MainWindow.vala"
	return FALSE;
#line 995 "MainWindow.c"
}

static void
pantheon_calculator_main_window_action_insert (PantheonCalculatorMainWindow* self,
                                               GSimpleAction* action,
                                               GVariant* variant)
{
	gchar* token = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint new_position = 0;
	GtkEntry* _tmp2_;
	gint selection_start = 0;
	gint selection_end = 0;
	gint selection_length = 0;
	gboolean is_text_selected = FALSE;
	GtkEntry* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gint cursor_position = 0;
	GtkEntry* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
#line 552 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 552 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 553 "../src/MainWindow.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 553 "../src/MainWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 553 "../src/MainWindow.vala"
	token = _tmp1_;
#line 554 "../src/MainWindow.vala"
	_tmp2_ = self->priv->entry;
#line 554 "../src/MainWindow.vala"
	new_position = gtk_editable_get_position ((GtkEditable*) _tmp2_);
#line 556 "../src/MainWindow.vala"
	_tmp3_ = self->priv->entry;
#line 556 "../src/MainWindow.vala"
	_tmp6_ = gtk_editable_get_selection_bounds ((GtkEditable*) _tmp3_, &_tmp4_, &_tmp5_);
#line 556 "../src/MainWindow.vala"
	selection_start = _tmp4_;
#line 556 "../src/MainWindow.vala"
	selection_end = _tmp5_;
#line 556 "../src/MainWindow.vala"
	is_text_selected = _tmp6_;
#line 557 "../src/MainWindow.vala"
	if (is_text_selected) {
#line 1051 "MainWindow.c"
		GtkEntry* _tmp7_;
#line 558 "../src/MainWindow.vala"
		new_position = selection_end;
#line 559 "../src/MainWindow.vala"
		_tmp7_ = self->priv->entry;
#line 559 "../src/MainWindow.vala"
		gtk_editable_delete_selection ((GtkEditable*) _tmp7_);
#line 560 "../src/MainWindow.vala"
		selection_length = selection_end - selection_start;
#line 561 "../src/MainWindow.vala"
		new_position -= selection_length;
#line 1063 "MainWindow.c"
	}
#line 564 "../src/MainWindow.vala"
	_tmp8_ = self->priv->entry;
#line 564 "../src/MainWindow.vala"
	g_object_get ((GtkEditable*) _tmp8_, "cursor-position", &_tmp9_, NULL);
#line 564 "../src/MainWindow.vala"
	_tmp10_ = _tmp9_;
#line 564 "../src/MainWindow.vala"
	cursor_position = _tmp10_;
#line 565 "../src/MainWindow.vala"
	_tmp11_ = self->priv->entry;
#line 565 "../src/MainWindow.vala"
	_tmp12_ = token;
#line 565 "../src/MainWindow.vala"
	gtk_editable_insert_text ((GtkEditable*) _tmp11_, _tmp12_, -1, &cursor_position);
#line 567 "../src/MainWindow.vala"
	_tmp13_ = token;
#line 567 "../src/MainWindow.vala"
	new_position += g_utf8_strlen (_tmp13_, (gssize) -1);
#line 568 "../src/MainWindow.vala"
	_tmp14_ = self->priv->entry;
#line 568 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp14_);
#line 569 "../src/MainWindow.vala"
	_tmp15_ = self->priv->entry;
#line 569 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp15_, new_position);
#line 552 "../src/MainWindow.vala"
	_g_free0 (token);
#line 1093 "MainWindow.c"
}

static void
pantheon_calculator_main_window_action_function (PantheonCalculatorMainWindow* self,
                                                 GSimpleAction* action,
                                                 GVariant* variant)
{
	gchar* token = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint selection_start = 0;
	gint selection_end = 0;
	GtkEntry* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
#line 572 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 572 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 573 "../src/MainWindow.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 573 "../src/MainWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 573 "../src/MainWindow.vala"
	token = _tmp1_;
#line 574 "../src/MainWindow.vala"
	selection_start = -1;
#line 575 "../src/MainWindow.vala"
	selection_end = -1;
#line 576 "../src/MainWindow.vala"
	_tmp2_ = self->priv->entry;
#line 576 "../src/MainWindow.vala"
	_tmp5_ = gtk_editable_get_selection_bounds ((GtkEditable*) _tmp2_, &_tmp3_, &_tmp4_);
#line 576 "../src/MainWindow.vala"
	selection_start = _tmp3_;
#line 576 "../src/MainWindow.vala"
	selection_end = _tmp4_;
#line 576 "../src/MainWindow.vala"
	if (_tmp5_) {
#line 1134 "MainWindow.c"
		gint new_position = 0;
		gchar* selected_text = NULL;
		GtkEntry* _tmp6_;
		gchar* _tmp7_;
		gchar* function_call = NULL;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GtkEntry* _tmp16_;
		GtkEntry* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		GtkEntry* _tmp20_;
		GtkEntry* _tmp21_;
#line 577 "../src/MainWindow.vala"
		new_position = selection_start;
#line 578 "../src/MainWindow.vala"
		_tmp6_ = self->priv->entry;
#line 578 "../src/MainWindow.vala"
		_tmp7_ = gtk_editable_get_chars ((GtkEditable*) _tmp6_, selection_start, selection_end);
#line 578 "../src/MainWindow.vala"
		selected_text = _tmp7_;
#line 579 "../src/MainWindow.vala"
		_tmp8_ = token;
#line 579 "../src/MainWindow.vala"
		_tmp9_ = g_strconcat (_tmp8_, "(", NULL);
#line 579 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 579 "../src/MainWindow.vala"
		_tmp11_ = selected_text;
#line 579 "../src/MainWindow.vala"
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 579 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 579 "../src/MainWindow.vala"
		_tmp14_ = g_strconcat (_tmp13_, ")", NULL);
#line 579 "../src/MainWindow.vala"
		_tmp15_ = _tmp14_;
#line 579 "../src/MainWindow.vala"
		_g_free0 (_tmp13_);
#line 579 "../src/MainWindow.vala"
		_g_free0 (_tmp10_);
#line 579 "../src/MainWindow.vala"
		function_call = _tmp15_;
#line 580 "../src/MainWindow.vala"
		_tmp16_ = self->priv->entry;
#line 580 "../src/MainWindow.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp16_, "delete-text", selection_start, selection_end);
#line 581 "../src/MainWindow.vala"
		_tmp17_ = self->priv->entry;
#line 581 "../src/MainWindow.vala"
		_tmp18_ = function_call;
#line 581 "../src/MainWindow.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp17_, "insert-text", _tmp18_, -1, &selection_start);
#line 582 "../src/MainWindow.vala"
		_tmp19_ = function_call;
#line 582 "../src/MainWindow.vala"
		new_position += g_utf8_strlen (_tmp19_, (gssize) -1);
#line 583 "../src/MainWindow.vala"
		_tmp20_ = self->priv->entry;
#line 583 "../src/MainWindow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp20_);
#line 584 "../src/MainWindow.vala"
		_tmp21_ = self->priv->entry;
#line 584 "../src/MainWindow.vala"
		gtk_editable_set_position ((GtkEditable*) _tmp21_, new_position);
#line 576 "../src/MainWindow.vala"
		_g_free0 (function_call);
#line 576 "../src/MainWindow.vala"
		_g_free0 (selected_text);
#line 1210 "MainWindow.c"
	} else {
#line 586 "../src/MainWindow.vala"
		g_action_group_activate_action ((GActionGroup*) self, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT, variant);
#line 1214 "MainWindow.c"
	}
#line 572 "../src/MainWindow.vala"
	_g_free0 (token);
#line 1218 "MainWindow.c"
}

static gpointer
_pantheon_calculator_main_window_history_dup0 (gpointer self)
{
#line 597 "../src/MainWindow.vala"
	return self ? pantheon_calculator_main_window_history_dup (self) : NULL;
#line 1226 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_calc_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	GtkEntry* _tmp32_;
	GtkEntry* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 590 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 591 "../src/MainWindow.vala"
	self->priv->position = gtk_editable_get_position ((GtkEditable*) _tmp0_);
#line 592 "../src/MainWindow.vala"
	_tmp1_ = self->priv->entry;
#line 592 "../src/MainWindow.vala"
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
#line 592 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp2_, "") != 0) {
#line 1250 "MainWindow.c"
		{
			gchar* output = NULL;
			PantheonCalculatorCoreEvaluation* _tmp3_;
			GtkEntry* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			GtkEntry* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 594 "../src/MainWindow.vala"
			_tmp3_ = self->priv->eval;
#line 594 "../src/MainWindow.vala"
			_tmp4_ = self->priv->entry;
#line 594 "../src/MainWindow.vala"
			_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 594 "../src/MainWindow.vala"
			_tmp6_ = pantheon_calculator_core_evaluation_evaluate (_tmp3_, _tmp5_, self->priv->decimal_places, &_inner_error0_);
#line 594 "../src/MainWindow.vala"
			output = _tmp6_;
#line 594 "../src/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 594 "../src/MainWindow.vala"
				if (_inner_error0_->domain == PANTHEON_CALCULATOR_CORE_OUT_ERROR) {
#line 1274 "MainWindow.c"
					goto __catch0_pantheon_calculator_core_out_error;
				}
#line 594 "../src/MainWindow.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 594 "../src/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 594 "../src/MainWindow.vala"
				return;
#line 1283 "MainWindow.c"
			}
#line 595 "../src/MainWindow.vala"
			_tmp7_ = self->priv->entry;
#line 595 "../src/MainWindow.vala"
			_tmp8_ = gtk_editable_get_text ((GtkEditable*) _tmp7_);
#line 595 "../src/MainWindow.vala"
			_tmp9_ = output;
#line 595 "../src/MainWindow.vala"
			if (g_strcmp0 (_tmp8_, _tmp9_) != 0) {
#line 1293 "MainWindow.c"
				PantheonCalculatorMainWindowHistory history_entry = {0};
				GtkEntry* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				PantheonCalculatorMainWindowHistory _tmp15_ = {0};
				PantheonCalculatorMainWindowHistory _tmp16_;
				PantheonCalculatorMainWindowHistory _tmp17_;
				PantheonCalculatorMainWindowHistory* _tmp18_;
				PantheonCalculatorMainWindowHistory _tmp19_;
				GtkEntry* _tmp20_;
				const gchar* _tmp21_;
				GtkButton* _tmp22_;
				GtkButton* _tmp23_;
				GtkButton* _tmp24_;
				const gchar* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 596 "../src/MainWindow.vala"
				_tmp10_ = self->priv->entry;
#line 596 "../src/MainWindow.vala"
				_tmp11_ = gtk_editable_get_text ((GtkEditable*) _tmp10_);
#line 596 "../src/MainWindow.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 596 "../src/MainWindow.vala"
				_tmp13_ = output;
#line 596 "../src/MainWindow.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 596 "../src/MainWindow.vala"
				memset (&_tmp15_, 0, sizeof (PantheonCalculatorMainWindowHistory));
#line 596 "../src/MainWindow.vala"
				_g_free0 (_tmp15_.exp);
#line 596 "../src/MainWindow.vala"
				_tmp15_.exp = _tmp12_;
#line 596 "../src/MainWindow.vala"
				_g_free0 (_tmp15_.output);
#line 596 "../src/MainWindow.vala"
				_tmp15_.output = _tmp14_;
#line 596 "../src/MainWindow.vala"
				history_entry = _tmp15_;
#line 597 "../src/MainWindow.vala"
				_tmp16_ = history_entry;
#line 597 "../src/MainWindow.vala"
				_tmp17_ = _tmp16_;
#line 597 "../src/MainWindow.vala"
				_tmp18_ = _pantheon_calculator_main_window_history_dup0 (&_tmp17_);
#line 597 "../src/MainWindow.vala"
				self->priv->history = g_list_append (self->priv->history, _tmp18_);
#line 598 "../src/MainWindow.vala"
				_tmp19_ = history_entry;
#line 598 "../src/MainWindow.vala"
				pantheon_calculator_main_window_update_history_dialog (self, &_tmp19_);
#line 599 "../src/MainWindow.vala"
				_tmp20_ = self->priv->entry;
#line 599 "../src/MainWindow.vala"
				_tmp21_ = output;
#line 599 "../src/MainWindow.vala"
				gtk_editable_set_text ((GtkEditable*) _tmp20_, _tmp21_);
#line 600 "../src/MainWindow.vala"
				_tmp22_ = self->priv->button_history;
#line 600 "../src/MainWindow.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, TRUE);
#line 601 "../src/MainWindow.vala"
				_tmp23_ = self->priv->button_ans;
#line 601 "../src/MainWindow.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, TRUE);
#line 602 "../src/MainWindow.vala"
				_tmp24_ = self->priv->button_gt;
#line 602 "../src/MainWindow.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, TRUE);
#line 604 "../src/MainWindow.vala"
				_tmp25_ = output;
#line 604 "../src/MainWindow.vala"
				_tmp26_ = strlen (_tmp25_);
#line 604 "../src/MainWindow.vala"
				_tmp27_ = _tmp26_;
#line 604 "../src/MainWindow.vala"
				self->priv->position = _tmp27_;
#line 605 "../src/MainWindow.vala"
				pantheon_calculator_main_window_remove_error (self);
#line 595 "../src/MainWindow.vala"
				pantheon_calculator_main_window_history_destroy (&history_entry);
#line 1377 "MainWindow.c"
			}
#line 593 "../src/MainWindow.vala"
			_g_free0 (output);
#line 1381 "MainWindow.c"
		}
		goto __finally0;
		__catch0_pantheon_calculator_core_out_error:
		{
			GError* e = NULL;
			GtkLabel* _tmp28_;
			GError* _tmp29_;
			const gchar* _tmp30_;
			GtkInfoBar* _tmp31_;
#line 593 "../src/MainWindow.vala"
			e = _inner_error0_;
#line 593 "../src/MainWindow.vala"
			_inner_error0_ = NULL;
#line 608 "../src/MainWindow.vala"
			_tmp28_ = self->priv->infobar_label;
#line 608 "../src/MainWindow.vala"
			_tmp29_ = e;
#line 608 "../src/MainWindow.vala"
			_tmp30_ = _tmp29_->message;
#line 608 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp28_, _tmp30_);
#line 609 "../src/MainWindow.vala"
			_tmp31_ = self->priv->infobar;
#line 609 "../src/MainWindow.vala"
			gtk_info_bar_set_revealed (_tmp31_, TRUE);
#line 593 "../src/MainWindow.vala"
			_g_error_free0 (e);
#line 1409 "MainWindow.c"
		}
		__finally0:
#line 593 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "../src/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 593 "../src/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 593 "../src/MainWindow.vala"
			return;
#line 1420 "MainWindow.c"
		}
	} else {
#line 612 "../src/MainWindow.vala"
		pantheon_calculator_main_window_remove_error (self);
#line 1425 "MainWindow.c"
	}
#line 615 "../src/MainWindow.vala"
	_tmp32_ = self->priv->entry;
#line 615 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp32_);
#line 616 "../src/MainWindow.vala"
	_tmp33_ = self->priv->entry;
#line 616 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp33_, self->priv->position);
#line 1435 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_reciprocal_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 619 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 620 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 620 "../src/MainWindow.vala"
	_tmp1_ = self->priv->entry;
#line 620 "../src/MainWindow.vala"
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
#line 620 "../src/MainWindow.vala"
	_tmp3_ = g_strconcat ("1/(", _tmp2_, NULL);
#line 620 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 620 "../src/MainWindow.vala"
	_tmp5_ = g_strconcat (_tmp4_, ")", NULL);
#line 620 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 620 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp6_);
#line 620 "../src/MainWindow.vala"
	_g_free0 (_tmp6_);
#line 620 "../src/MainWindow.vala"
	_g_free0 (_tmp4_);
#line 621 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_calc_clicked (self);
#line 1472 "MainWindow.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1259 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1260 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1261 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1488 "MainWindow.c"
		gchar* _tmp0_;
#line 1262 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1262 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1263 "glib-2.0.vapi"
		result = TRUE;
#line 1263 "glib-2.0.vapi"
		if (c) {
#line 1263 "glib-2.0.vapi"
			*c = _vala_c;
#line 1500 "MainWindow.c"
		}
#line 1263 "glib-2.0.vapi"
		return result;
#line 1504 "MainWindow.c"
	} else {
#line 1265 "glib-2.0.vapi"
		result = FALSE;
#line 1265 "glib-2.0.vapi"
		if (c) {
#line 1265 "glib-2.0.vapi"
			*c = _vala_c;
#line 1512 "MainWindow.c"
		}
#line 1265 "glib-2.0.vapi"
		return result;
#line 1516 "MainWindow.c"
	}
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1079 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1079 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1080 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1081 "glib-2.0.vapi"
	result = str;
#line 1081 "glib-2.0.vapi"
	return result;
#line 1536 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_del_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
#line 624 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 625 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 625 "../src/MainWindow.vala"
	self->priv->position = gtk_editable_get_position ((GtkEditable*) _tmp0_);
#line 626 "../src/MainWindow.vala"
	_tmp1_ = self->priv->entry;
#line 626 "../src/MainWindow.vala"
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
#line 626 "../src/MainWindow.vala"
	_tmp3_ = strlen (_tmp2_);
#line 626 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 626 "../src/MainWindow.vala"
	if (_tmp4_ > 0) {
#line 1565 "MainWindow.c"
		gchar* new_text = NULL;
		gchar* _tmp5_;
		gint index = 0;
		gunichar c = 0U;
		GList* news = NULL;
		GList* _tmp12_;
		GtkEntry* _tmp17_;
		const gchar* _tmp18_;
#line 627 "../src/MainWindow.vala"
		_tmp5_ = g_strdup ("");
#line 627 "../src/MainWindow.vala"
		new_text = _tmp5_;
#line 628 "../src/MainWindow.vala"
		index = 0;
#line 630 "../src/MainWindow.vala"
		news = NULL;
#line 1582 "MainWindow.c"
		{
			gint i = 0;
#line 632 "../src/MainWindow.vala"
			i = 0;
#line 1587 "MainWindow.c"
			{
				gboolean _tmp6_ = FALSE;
#line 632 "../src/MainWindow.vala"
				_tmp6_ = TRUE;
#line 632 "../src/MainWindow.vala"
				while (TRUE) {
#line 1594 "MainWindow.c"
					GtkEntry* _tmp8_;
					const gchar* _tmp9_;
					gunichar _tmp10_ = 0U;
					gboolean _tmp11_;
#line 632 "../src/MainWindow.vala"
					if (!_tmp6_) {
#line 1601 "MainWindow.c"
						gint _tmp7_;
#line 632 "../src/MainWindow.vala"
						_tmp7_ = i;
#line 632 "../src/MainWindow.vala"
						i = _tmp7_ + 1;
#line 1607 "MainWindow.c"
					}
#line 632 "../src/MainWindow.vala"
					_tmp6_ = FALSE;
#line 632 "../src/MainWindow.vala"
					_tmp8_ = self->priv->entry;
#line 632 "../src/MainWindow.vala"
					_tmp9_ = gtk_editable_get_text ((GtkEditable*) _tmp8_);
#line 632 "../src/MainWindow.vala"
					_tmp11_ = string_get_next_char (_tmp9_, &index, &_tmp10_);
#line 632 "../src/MainWindow.vala"
					c = _tmp10_;
#line 632 "../src/MainWindow.vala"
					if (!_tmp11_) {
#line 632 "../src/MainWindow.vala"
						break;
#line 1623 "MainWindow.c"
					}
#line 633 "../src/MainWindow.vala"
					if ((i + 1) != self->priv->position) {
#line 634 "../src/MainWindow.vala"
						news = g_list_append (news, (gpointer) ((gintptr) c));
#line 1629 "MainWindow.c"
					}
				}
			}
		}
#line 638 "../src/MainWindow.vala"
		_tmp12_ = news;
#line 1636 "MainWindow.c"
		{
			GList* u_collection = NULL;
			GList* u_it = NULL;
#line 638 "../src/MainWindow.vala"
			u_collection = _tmp12_;
#line 638 "../src/MainWindow.vala"
			for (u_it = u_collection; u_it != NULL; u_it = u_it->next) {
#line 1644 "MainWindow.c"
				gunichar u = 0U;
#line 638 "../src/MainWindow.vala"
				u = (gunichar) ((gintptr) u_it->data);
#line 1648 "MainWindow.c"
				{
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
#line 639 "../src/MainWindow.vala"
					_tmp13_ = new_text;
#line 639 "../src/MainWindow.vala"
					_tmp14_ = g_unichar_to_string (u);
#line 639 "../src/MainWindow.vala"
					_tmp15_ = _tmp14_;
#line 639 "../src/MainWindow.vala"
					_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
#line 639 "../src/MainWindow.vala"
					_g_free0 (new_text);
#line 639 "../src/MainWindow.vala"
					new_text = _tmp16_;
#line 639 "../src/MainWindow.vala"
					_g_free0 (_tmp15_);
#line 1668 "MainWindow.c"
				}
			}
		}
#line 642 "../src/MainWindow.vala"
		_tmp17_ = self->priv->entry;
#line 642 "../src/MainWindow.vala"
		_tmp18_ = new_text;
#line 642 "../src/MainWindow.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp17_, _tmp18_);
#line 626 "../src/MainWindow.vala"
		(news == NULL) ? NULL : (news = (g_list_free (news), NULL));
#line 626 "../src/MainWindow.vala"
		_g_free0 (new_text);
#line 1682 "MainWindow.c"
	}
#line 645 "../src/MainWindow.vala"
	_tmp19_ = self->priv->entry;
#line 645 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 646 "../src/MainWindow.vala"
	_tmp20_ = self->priv->entry;
#line 646 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp20_, self->priv->position - 1);
#line 1692 "MainWindow.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 1705 "MainWindow.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1727 "MainWindow.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1731 "MainWindow.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1737 "MainWindow.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1741 "MainWindow.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1745 "MainWindow.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 1753 "MainWindow.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1781 "MainWindow.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 1790 "MainWindow.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1804 "MainWindow.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 1813 "MainWindow.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 1827 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1836 "MainWindow.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 1845 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_memory_store_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 649 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 650 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 650 "../src/MainWindow.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 650 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 1862 "MainWindow.c"
		{
			gchar* output = NULL;
			PantheonCalculatorCoreEvaluation* _tmp2_;
			GtkEntry* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			PantheonCalculatorCoreEvaluation* _tmp7_;
			PantheonCalculatorCoreScanner* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GtkButton* _tmp13_;
			GtkButton* _tmp14_;
#line 662 "../src/MainWindow.vala"
			_tmp2_ = self->priv->eval;
#line 662 "../src/MainWindow.vala"
			_tmp3_ = self->priv->entry;
#line 662 "../src/MainWindow.vala"
			_tmp4_ = gtk_editable_get_text ((GtkEditable*) _tmp3_);
#line 662 "../src/MainWindow.vala"
			_tmp5_ = pantheon_calculator_core_evaluation_evaluate (_tmp2_, _tmp4_, self->priv->decimal_places, &_inner_error0_);
#line 662 "../src/MainWindow.vala"
			output = _tmp5_;
#line 662 "../src/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 662 "../src/MainWindow.vala"
				if (_inner_error0_->domain == PANTHEON_CALCULATOR_CORE_OUT_ERROR) {
#line 1892 "MainWindow.c"
					goto __catch0_pantheon_calculator_core_out_error;
				}
#line 662 "../src/MainWindow.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 662 "../src/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 662 "../src/MainWindow.vala"
				return;
#line 1901 "MainWindow.c"
			}
#line 663 "../src/MainWindow.vala"
			_tmp6_ = output;
#line 663 "../src/MainWindow.vala"
			_tmp7_ = self->priv->eval;
#line 663 "../src/MainWindow.vala"
			_tmp8_ = _tmp7_->scanner;
#line 663 "../src/MainWindow.vala"
			_tmp9_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp8_);
#line 663 "../src/MainWindow.vala"
			_tmp10_ = _tmp9_;
#line 663 "../src/MainWindow.vala"
			_tmp11_ = string_replace (_tmp6_, _tmp10_, ".");
#line 663 "../src/MainWindow.vala"
			_tmp12_ = _tmp11_;
#line 663 "../src/MainWindow.vala"
			self->priv->memory_value = double_parse (_tmp12_);
#line 663 "../src/MainWindow.vala"
			_g_free0 (_tmp12_);
#line 665 "../src/MainWindow.vala"
			_tmp13_ = self->priv->button_mr;
#line 665 "../src/MainWindow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
#line 666 "../src/MainWindow.vala"
			_tmp14_ = self->priv->button_mc;
#line 666 "../src/MainWindow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
#line 651 "../src/MainWindow.vala"
			_g_free0 (output);
#line 1931 "MainWindow.c"
		}
		goto __finally0;
		__catch0_pantheon_calculator_core_out_error:
		{
			GError* e = NULL;
			GtkLabel* _tmp15_;
			GError* _tmp16_;
			const gchar* _tmp17_;
			GtkInfoBar* _tmp18_;
#line 651 "../src/MainWindow.vala"
			e = _inner_error0_;
#line 651 "../src/MainWindow.vala"
			_inner_error0_ = NULL;
#line 668 "../src/MainWindow.vala"
			_tmp15_ = self->priv->infobar_label;
#line 668 "../src/MainWindow.vala"
			_tmp16_ = e;
#line 668 "../src/MainWindow.vala"
			_tmp17_ = _tmp16_->message;
#line 668 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp15_, _tmp17_);
#line 669 "../src/MainWindow.vala"
			_tmp18_ = self->priv->infobar;
#line 669 "../src/MainWindow.vala"
			gtk_info_bar_set_revealed (_tmp18_, TRUE);
#line 651 "../src/MainWindow.vala"
			_g_error_free0 (e);
#line 1959 "MainWindow.c"
		}
		__finally0:
#line 651 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "../src/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 651 "../src/MainWindow.vala"
			return;
#line 1970 "MainWindow.c"
		}
	}
}

static void
pantheon_calculator_main_window_button_memory_add_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 676 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 677 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 677 "../src/MainWindow.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 677 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 1989 "MainWindow.c"
		{
			gchar* output = NULL;
			PantheonCalculatorCoreEvaluation* _tmp2_;
			GtkEntry* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			PantheonCalculatorCoreEvaluation* _tmp7_;
			PantheonCalculatorCoreScanner* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 679 "../src/MainWindow.vala"
			_tmp2_ = self->priv->eval;
#line 679 "../src/MainWindow.vala"
			_tmp3_ = self->priv->entry;
#line 679 "../src/MainWindow.vala"
			_tmp4_ = gtk_editable_get_text ((GtkEditable*) _tmp3_);
#line 679 "../src/MainWindow.vala"
			_tmp5_ = pantheon_calculator_core_evaluation_evaluate (_tmp2_, _tmp4_, self->priv->decimal_places, &_inner_error0_);
#line 679 "../src/MainWindow.vala"
			output = _tmp5_;
#line 679 "../src/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 679 "../src/MainWindow.vala"
				if (_inner_error0_->domain == PANTHEON_CALCULATOR_CORE_OUT_ERROR) {
#line 2017 "MainWindow.c"
					goto __catch0_pantheon_calculator_core_out_error;
				}
#line 679 "../src/MainWindow.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 679 "../src/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 679 "../src/MainWindow.vala"
				return;
#line 2026 "MainWindow.c"
			}
#line 680 "../src/MainWindow.vala"
			_tmp6_ = output;
#line 680 "../src/MainWindow.vala"
			_tmp7_ = self->priv->eval;
#line 680 "../src/MainWindow.vala"
			_tmp8_ = _tmp7_->scanner;
#line 680 "../src/MainWindow.vala"
			_tmp9_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp8_);
#line 680 "../src/MainWindow.vala"
			_tmp10_ = _tmp9_;
#line 680 "../src/MainWindow.vala"
			_tmp11_ = string_replace (_tmp6_, _tmp10_, ".");
#line 680 "../src/MainWindow.vala"
			_tmp12_ = _tmp11_;
#line 680 "../src/MainWindow.vala"
			self->priv->memory_value = self->priv->memory_value + double_parse (_tmp12_);
#line 680 "../src/MainWindow.vala"
			_g_free0 (_tmp12_);
#line 678 "../src/MainWindow.vala"
			_g_free0 (output);
#line 2048 "MainWindow.c"
		}
		goto __finally0;
		__catch0_pantheon_calculator_core_out_error:
		{
			GError* e = NULL;
			GtkLabel* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
			GtkInfoBar* _tmp16_;
#line 678 "../src/MainWindow.vala"
			e = _inner_error0_;
#line 678 "../src/MainWindow.vala"
			_inner_error0_ = NULL;
#line 682 "../src/MainWindow.vala"
			_tmp13_ = self->priv->infobar_label;
#line 682 "../src/MainWindow.vala"
			_tmp14_ = e;
#line 682 "../src/MainWindow.vala"
			_tmp15_ = _tmp14_->message;
#line 682 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp13_, _tmp15_);
#line 683 "../src/MainWindow.vala"
			_tmp16_ = self->priv->infobar;
#line 683 "../src/MainWindow.vala"
			gtk_info_bar_set_revealed (_tmp16_, TRUE);
#line 678 "../src/MainWindow.vala"
			_g_error_free0 (e);
#line 2076 "MainWindow.c"
		}
		__finally0:
#line 678 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 678 "../src/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 678 "../src/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 678 "../src/MainWindow.vala"
			return;
#line 2087 "MainWindow.c"
		}
	}
}

static void
pantheon_calculator_main_window_button_memory_subtract_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 688 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 689 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 689 "../src/MainWindow.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 689 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 2106 "MainWindow.c"
		{
			gchar* output = NULL;
			PantheonCalculatorCoreEvaluation* _tmp2_;
			GtkEntry* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			PantheonCalculatorCoreEvaluation* _tmp7_;
			PantheonCalculatorCoreScanner* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 691 "../src/MainWindow.vala"
			_tmp2_ = self->priv->eval;
#line 691 "../src/MainWindow.vala"
			_tmp3_ = self->priv->entry;
#line 691 "../src/MainWindow.vala"
			_tmp4_ = gtk_editable_get_text ((GtkEditable*) _tmp3_);
#line 691 "../src/MainWindow.vala"
			_tmp5_ = pantheon_calculator_core_evaluation_evaluate (_tmp2_, _tmp4_, self->priv->decimal_places, &_inner_error0_);
#line 691 "../src/MainWindow.vala"
			output = _tmp5_;
#line 691 "../src/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 691 "../src/MainWindow.vala"
				if (_inner_error0_->domain == PANTHEON_CALCULATOR_CORE_OUT_ERROR) {
#line 2134 "MainWindow.c"
					goto __catch0_pantheon_calculator_core_out_error;
				}
#line 691 "../src/MainWindow.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 691 "../src/MainWindow.vala"
				g_clear_error (&_inner_error0_);
#line 691 "../src/MainWindow.vala"
				return;
#line 2143 "MainWindow.c"
			}
#line 692 "../src/MainWindow.vala"
			_tmp6_ = output;
#line 692 "../src/MainWindow.vala"
			_tmp7_ = self->priv->eval;
#line 692 "../src/MainWindow.vala"
			_tmp8_ = _tmp7_->scanner;
#line 692 "../src/MainWindow.vala"
			_tmp9_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp8_);
#line 692 "../src/MainWindow.vala"
			_tmp10_ = _tmp9_;
#line 692 "../src/MainWindow.vala"
			_tmp11_ = string_replace (_tmp6_, _tmp10_, ".");
#line 692 "../src/MainWindow.vala"
			_tmp12_ = _tmp11_;
#line 692 "../src/MainWindow.vala"
			self->priv->memory_value = self->priv->memory_value - double_parse (_tmp12_);
#line 692 "../src/MainWindow.vala"
			_g_free0 (_tmp12_);
#line 690 "../src/MainWindow.vala"
			_g_free0 (output);
#line 2165 "MainWindow.c"
		}
		goto __finally0;
		__catch0_pantheon_calculator_core_out_error:
		{
			GError* e = NULL;
			GtkLabel* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
			GtkInfoBar* _tmp16_;
#line 690 "../src/MainWindow.vala"
			e = _inner_error0_;
#line 690 "../src/MainWindow.vala"
			_inner_error0_ = NULL;
#line 694 "../src/MainWindow.vala"
			_tmp13_ = self->priv->infobar_label;
#line 694 "../src/MainWindow.vala"
			_tmp14_ = e;
#line 694 "../src/MainWindow.vala"
			_tmp15_ = _tmp14_->message;
#line 694 "../src/MainWindow.vala"
			gtk_label_set_label (_tmp13_, _tmp15_);
#line 695 "../src/MainWindow.vala"
			_tmp16_ = self->priv->infobar;
#line 695 "../src/MainWindow.vala"
			gtk_info_bar_set_revealed (_tmp16_, TRUE);
#line 690 "../src/MainWindow.vala"
			_g_error_free0 (e);
#line 2193 "MainWindow.c"
		}
		__finally0:
#line 690 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 690 "../src/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 690 "../src/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 690 "../src/MainWindow.vala"
			return;
#line 2204 "MainWindow.c"
		}
	}
}

static void
pantheon_calculator_main_window_button_memory_clear_clicked (PantheonCalculatorMainWindow* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 700 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/MainWindow.vala"
	self->priv->memory_value = (gdouble) 0;
#line 702 "../src/MainWindow.vala"
	_tmp0_ = self->priv->button_mr;
#line 702 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 703 "../src/MainWindow.vala"
	_tmp1_ = self->priv->button_mc;
#line 703 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 2226 "MainWindow.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 706 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 706 "../src/MainWindow.vala"
	return _data2_;
#line 2236 "MainWindow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 706 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2246 "MainWindow.c"
		PantheonCalculatorMainWindow* self;
#line 706 "../src/MainWindow.vala"
		self = _data2_->self;
#line 706 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 706 "../src/MainWindow.vala"
		g_slice_free (Block2Data, _data2_);
#line 2254 "MainWindow.c"
	}
}

static void
__lambda34_ (Block2Data* _data2_,
             PantheonCalculatorMainWindowHistory* list_entry)
{
	PantheonCalculatorMainWindow* self;
	const gchar* _tmp0_;
	PantheonCalculatorCoreEvaluation* _tmp1_;
	PantheonCalculatorCoreScanner* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 710 "../src/MainWindow.vala"
	self = _data2_->self;
#line 711 "../src/MainWindow.vala"
	_tmp0_ = (*list_entry).output;
#line 711 "../src/MainWindow.vala"
	_tmp1_ = self->priv->eval;
#line 711 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_->scanner;
#line 711 "../src/MainWindow.vala"
	_tmp3_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp2_);
#line 711 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 711 "../src/MainWindow.vala"
	_tmp5_ = string_replace (_tmp0_, _tmp4_, ".");
#line 711 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 711 "../src/MainWindow.vala"
	_data2_->grand_total += double_parse (_tmp6_);
#line 711 "../src/MainWindow.vala"
	_g_free0 (_tmp6_);
#line 2290 "MainWindow.c"
}

static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
#line 710 "../src/MainWindow.vala"
	__lambda34_ (self, (PantheonCalculatorMainWindowHistory*) data);
#line 2299 "MainWindow.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 2330 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_gt_clicked (PantheonCalculatorMainWindow* self)
{
	Block2Data* _data2_;
	GList* _tmp0_;
	GtkEntry* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkEntry* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 706 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 706 "../src/MainWindow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 706 "../src/MainWindow.vala"
	_data2_->_ref_count_ = 1;
#line 706 "../src/MainWindow.vala"
	_data2_->self = g_object_ref (self);
#line 707 "../src/MainWindow.vala"
	pantheon_calculator_main_window_action_clear (self);
#line 709 "../src/MainWindow.vala"
	_data2_->grand_total = (gdouble) 0;
#line 710 "../src/MainWindow.vala"
	_tmp0_ = self->priv->history;
#line 710 "../src/MainWindow.vala"
	g_list_foreach (_tmp0_, ___lambda34__gfunc, _data2_);
#line 714 "../src/MainWindow.vala"
	_tmp1_ = self->priv->entry;
#line 714 "../src/MainWindow.vala"
	_tmp2_ = pantheon_calculator_main_window_number_to_string (self, _data2_->grand_total);
#line 714 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 714 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp1_, _tmp3_);
#line 714 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 715 "../src/MainWindow.vala"
	_tmp4_ = self->priv->entry;
#line 715 "../src/MainWindow.vala"
	_tmp5_ = double_to_string (_data2_->grand_total);
#line 715 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 715 "../src/MainWindow.vala"
	_tmp7_ = strlen (_tmp6_);
#line 715 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 715 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp4_, _tmp8_);
#line 715 "../src/MainWindow.vala"
	_g_free0 (_tmp6_);
#line 706 "../src/MainWindow.vala"
	block2_data_unref (_data2_);
#line 706 "../src/MainWindow.vala"
	_data2_ = NULL;
#line 2390 "MainWindow.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2414 "MainWindow.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 2422 "MainWindow.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 2428 "MainWindow.c"
	}
}

static gchar*
pantheon_calculator_main_window_number_to_string (PantheonCalculatorMainWindow* self,
                                                  gdouble number)
{
	gchar* shortened_number = NULL;
	gchar* _tmp0_;
	gchar* number_localized = NULL;
	const gchar* _tmp1_;
	PantheonCalculatorCoreEvaluation* _tmp2_;
	PantheonCalculatorCoreScanner* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp10_;
	PantheonCalculatorCoreEvaluation* _tmp11_;
	PantheonCalculatorCoreScanner* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GString* builder = NULL;
	const gchar* _tmp17_;
	GString* _tmp18_;
	gint decimal_pos = 0;
	const gchar* _tmp19_;
	PantheonCalculatorCoreEvaluation* _tmp20_;
	PantheonCalculatorCoreScanner* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gint end_position = 0;
	const gchar* _tmp27_;
	GString* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* result;
#line 724 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 725 "../src/MainWindow.vala"
	_tmp0_ = g_strdup_printf ("%.9f", number);
#line 725 "../src/MainWindow.vala"
	shortened_number = _tmp0_;
#line 726 "../src/MainWindow.vala"
	_tmp1_ = shortened_number;
#line 726 "../src/MainWindow.vala"
	_tmp2_ = self->priv->eval;
#line 726 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_->scanner;
#line 726 "../src/MainWindow.vala"
	_tmp4_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp3_);
#line 726 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 726 "../src/MainWindow.vala"
	_tmp6_ = string_replace (_tmp1_, ".", _tmp5_);
#line 726 "../src/MainWindow.vala"
	number_localized = _tmp6_;
#line 729 "../src/MainWindow.vala"
	while (TRUE) {
#line 2487 "MainWindow.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 729 "../src/MainWindow.vala"
		_tmp7_ = number_localized;
#line 729 "../src/MainWindow.vala"
		if (!g_str_has_suffix (_tmp7_, "0")) {
#line 729 "../src/MainWindow.vala"
			break;
#line 2497 "MainWindow.c"
		}
#line 730 "../src/MainWindow.vala"
		_tmp8_ = number_localized;
#line 730 "../src/MainWindow.vala"
		_tmp9_ = string_slice (_tmp8_, (glong) 0, (glong) -1);
#line 730 "../src/MainWindow.vala"
		_g_free0 (number_localized);
#line 730 "../src/MainWindow.vala"
		number_localized = _tmp9_;
#line 2507 "MainWindow.c"
	}
#line 732 "../src/MainWindow.vala"
	_tmp10_ = number_localized;
#line 732 "../src/MainWindow.vala"
	_tmp11_ = self->priv->eval;
#line 732 "../src/MainWindow.vala"
	_tmp12_ = _tmp11_->scanner;
#line 732 "../src/MainWindow.vala"
	_tmp13_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp12_);
#line 732 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_;
#line 732 "../src/MainWindow.vala"
	if (g_str_has_suffix (_tmp10_, _tmp14_)) {
#line 2521 "MainWindow.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 733 "../src/MainWindow.vala"
		_tmp15_ = number_localized;
#line 733 "../src/MainWindow.vala"
		_tmp16_ = string_slice (_tmp15_, (glong) 0, (glong) -1);
#line 733 "../src/MainWindow.vala"
		_g_free0 (number_localized);
#line 733 "../src/MainWindow.vala"
		number_localized = _tmp16_;
#line 2532 "MainWindow.c"
	}
#line 737 "../src/MainWindow.vala"
	_tmp17_ = number_localized;
#line 737 "../src/MainWindow.vala"
	_tmp18_ = g_string_new (_tmp17_);
#line 737 "../src/MainWindow.vala"
	builder = _tmp18_;
#line 738 "../src/MainWindow.vala"
	_tmp19_ = number_localized;
#line 738 "../src/MainWindow.vala"
	_tmp20_ = self->priv->eval;
#line 738 "../src/MainWindow.vala"
	_tmp21_ = _tmp20_->scanner;
#line 738 "../src/MainWindow.vala"
	_tmp22_ = pantheon_calculator_core_scanner_get_decimal_symbol (_tmp21_);
#line 738 "../src/MainWindow.vala"
	_tmp23_ = _tmp22_;
#line 738 "../src/MainWindow.vala"
	decimal_pos = string_last_index_of (_tmp19_, _tmp23_, 0);
#line 739 "../src/MainWindow.vala"
	if (decimal_pos == -1) {
#line 2554 "MainWindow.c"
		const gchar* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 740 "../src/MainWindow.vala"
		_tmp24_ = number_localized;
#line 740 "../src/MainWindow.vala"
		_tmp25_ = strlen (_tmp24_);
#line 740 "../src/MainWindow.vala"
		_tmp26_ = _tmp25_;
#line 740 "../src/MainWindow.vala"
		decimal_pos = _tmp26_;
#line 2566 "MainWindow.c"
	}
#line 743 "../src/MainWindow.vala"
	end_position = 0;
#line 744 "../src/MainWindow.vala"
	_tmp27_ = number_localized;
#line 744 "../src/MainWindow.vala"
	if (g_str_has_prefix (_tmp27_, "-")) {
#line 745 "../src/MainWindow.vala"
		end_position = 1;
#line 2576 "MainWindow.c"
	}
	{
		gint i = 0;
#line 747 "../src/MainWindow.vala"
		i = decimal_pos - 3;
#line 2582 "MainWindow.c"
		{
			gboolean _tmp28_ = FALSE;
#line 747 "../src/MainWindow.vala"
			_tmp28_ = TRUE;
#line 747 "../src/MainWindow.vala"
			while (TRUE) {
#line 2589 "MainWindow.c"
				GString* _tmp29_;
				PantheonCalculatorCoreEvaluation* _tmp30_;
				PantheonCalculatorCoreScanner* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
#line 747 "../src/MainWindow.vala"
				if (!_tmp28_) {
#line 747 "../src/MainWindow.vala"
					i -= 3;
#line 2599 "MainWindow.c"
				}
#line 747 "../src/MainWindow.vala"
				_tmp28_ = FALSE;
#line 747 "../src/MainWindow.vala"
				if (!(i > end_position)) {
#line 747 "../src/MainWindow.vala"
					break;
#line 2607 "MainWindow.c"
				}
#line 748 "../src/MainWindow.vala"
				_tmp29_ = builder;
#line 748 "../src/MainWindow.vala"
				_tmp30_ = self->priv->eval;
#line 748 "../src/MainWindow.vala"
				_tmp31_ = _tmp30_->scanner;
#line 748 "../src/MainWindow.vala"
				_tmp32_ = pantheon_calculator_core_scanner_get_separator_symbol (_tmp31_);
#line 748 "../src/MainWindow.vala"
				_tmp33_ = _tmp32_;
#line 748 "../src/MainWindow.vala"
				g_string_insert (_tmp29_, (gssize) i, _tmp33_);
#line 2621 "MainWindow.c"
			}
		}
	}
#line 751 "../src/MainWindow.vala"
	_tmp34_ = builder;
#line 751 "../src/MainWindow.vala"
	_tmp35_ = _tmp34_->str;
#line 751 "../src/MainWindow.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 751 "../src/MainWindow.vala"
	result = _tmp36_;
#line 751 "../src/MainWindow.vala"
	_g_string_free0 (builder);
#line 751 "../src/MainWindow.vala"
	_g_free0 (number_localized);
#line 751 "../src/MainWindow.vala"
	_g_free0 (shortened_number);
#line 751 "../src/MainWindow.vala"
	return result;
#line 2641 "MainWindow.c"
}

static void
pantheon_calculator_main_window_action_clear (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
#line 754 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/MainWindow.vala"
	self->priv->position = 0;
#line 756 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 756 "../src/MainWindow.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, "");
#line 757 "../src/MainWindow.vala"
	_tmp1_ = self->priv->entry;
#line 757 "../src/MainWindow.vala"
	gtk_root_set_focus ((GtkRoot*) self, (GtkWidget*) _tmp1_);
#line 758 "../src/MainWindow.vala"
	pantheon_calculator_main_window_remove_error (self);
#line 760 "../src/MainWindow.vala"
	_tmp2_ = self->priv->entry;
#line 760 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 761 "../src/MainWindow.vala"
	_tmp3_ = self->priv->entry;
#line 761 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp3_, self->priv->position);
#line 2673 "MainWindow.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 2686 "MainWindow.c"
}

static void
pantheon_calculator_main_window_button_ans_clicked (PantheonCalculatorMainWindow* self)
{
	GtkEntry* _tmp0_;
	GList* _tmp1_;
#line 764 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 765 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 765 "../src/MainWindow.vala"
	self->priv->position = gtk_editable_get_position ((GtkEditable*) _tmp0_);
#line 766 "../src/MainWindow.vala"
	_tmp1_ = self->priv->history;
#line 766 "../src/MainWindow.vala"
	if (((gint) g_list_length (_tmp1_)) > 0) {
#line 2704 "MainWindow.c"
		GList* last = NULL;
		GList* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
		gconstpointer _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 767 "../src/MainWindow.vala"
		_tmp2_ = self->priv->history;
#line 767 "../src/MainWindow.vala"
		_tmp3_ = g_list_last (_tmp2_);
#line 767 "../src/MainWindow.vala"
		last = _tmp3_;
#line 768 "../src/MainWindow.vala"
		_tmp4_ = last;
#line 768 "../src/MainWindow.vala"
		_tmp5_ = _tmp4_->data;
#line 768 "../src/MainWindow.vala"
		_tmp6_ = (*((PantheonCalculatorMainWindowHistory*) _tmp5_)).output;
#line 768 "../src/MainWindow.vala"
		_tmp7_ = string_to_string (_tmp6_);
#line 768 "../src/MainWindow.vala"
		pantheon_calculator_main_window_history_added (self, _tmp7_);
#line 2728 "MainWindow.c"
	}
}

static void
pantheon_calculator_main_window_toggle_grid (PantheonCalculatorMainWindow* self,
                                             GtkToggleButton* button)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
#line 772 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 772 "../src/MainWindow.vala"
	g_return_if_fail (button != NULL);
#line 773 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 773 "../src/MainWindow.vala"
	self->priv->position = gtk_editable_get_position ((GtkEditable*) _tmp0_);
#line 774 "../src/MainWindow.vala"
	if (gtk_toggle_button_get_active (button)) {
#line 2749 "MainWindow.c"
		GtkRevealer* _tmp1_;
#line 776 "../src/MainWindow.vala"
		gtk_button_set_icon_name ((GtkButton*) button, "pane-show-symbolic");
#line 777 "../src/MainWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, _ ("Hide extended functionality"));
#line 778 "../src/MainWindow.vala"
		_tmp1_ = self->priv->extended_revealer;
#line 778 "../src/MainWindow.vala"
		gtk_revealer_set_reveal_child (_tmp1_, TRUE);
#line 2759 "MainWindow.c"
	} else {
		GtkRevealer* _tmp2_;
#line 781 "../src/MainWindow.vala"
		gtk_button_set_icon_name ((GtkButton*) button, "pane-hide-symbolic");
#line 782 "../src/MainWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, _ ("Show extended functionality"));
#line 783 "../src/MainWindow.vala"
		_tmp2_ = self->priv->extended_revealer;
#line 783 "../src/MainWindow.vala"
		gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 2770 "MainWindow.c"
	}
#line 786 "../src/MainWindow.vala"
	_tmp3_ = self->priv->entry;
#line 786 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 787 "../src/MainWindow.vala"
	_tmp4_ = self->priv->entry;
#line 787 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp4_, self->priv->position);
#line 2780 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_history_added_pantheon_calculator_history_dialog_added (PantheonCalculatorHistoryDialog* _sender,
                                                                                         const gchar* text,
                                                                                         gpointer self)
{
#line 798 "../src/MainWindow.vala"
	pantheon_calculator_main_window_history_added ((PantheonCalculatorMainWindow*) self, text);
#line 2790 "MainWindow.c"
}

static void
__lambda36_ (PantheonCalculatorMainWindow* self,
             PantheonCalculatorMainWindowHistory* entry)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 801 "../src/MainWindow.vala"
	_tmp0_ = self->priv->history;
#line 801 "../src/MainWindow.vala"
	_tmp1_ = g_list_find (_tmp0_, entry);
#line 801 "../src/MainWindow.vala"
	self->priv->history = g_list_delete_link (self->priv->history, _tmp1_);
#line 2805 "MainWindow.c"
}

static void
___lambda36__gfunc (gconstpointer data,
                    gpointer self)
{
#line 800 "../src/MainWindow.vala"
	__lambda36_ ((PantheonCalculatorMainWindow*) self, (PantheonCalculatorMainWindowHistory*) data);
#line 2814 "MainWindow.c"
}

static void
__lambda35_ (PantheonCalculatorMainWindow* self)
{
	GList* _tmp0_;
	GtkButton* _tmp1_;
#line 800 "../src/MainWindow.vala"
	_tmp0_ = self->priv->history;
#line 800 "../src/MainWindow.vala"
	g_list_foreach (_tmp0_, ___lambda36__gfunc, self);
#line 803 "../src/MainWindow.vala"
	_tmp1_ = self->priv->button_ans;
#line 803 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 2830 "MainWindow.c"
}

static void
___lambda35__pantheon_calculator_history_dialog_clear_history (PantheonCalculatorHistoryDialog* _sender,
                                                               gpointer self)
{
#line 799 "../src/MainWindow.vala"
	__lambda35_ ((PantheonCalculatorMainWindow*) self);
#line 2839 "MainWindow.c"
}

static void
__lambda37_ (PantheonCalculatorMainWindow* self)
{
	GtkButton* _tmp0_;
	GList* _tmp1_;
#line 806 "../src/MainWindow.vala"
	_tmp0_ = self->priv->button_history;
#line 806 "../src/MainWindow.vala"
	_tmp1_ = self->priv->history;
#line 806 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_ != NULL);
#line 2853 "MainWindow.c"
}

static void
___lambda37__gtk_widget_hide (GtkWidget* _sender,
                              gpointer self)
{
#line 805 "../src/MainWindow.vala"
	__lambda37_ ((PantheonCalculatorMainWindow*) self);
#line 2862 "MainWindow.c"
}

static void
pantheon_calculator_main_window_show_history (PantheonCalculatorMainWindow* self,
                                              GtkButton* button)
{
	GtkEntry* _tmp0_;
	GList* _tmp1_;
	GtkWindow* _tmp2_;
	PantheonCalculatorHistoryDialog* _tmp3_ = NULL;
	PantheonCalculatorHistoryDialog* _tmp4_;
	PantheonCalculatorHistoryDialog* _tmp5_;
	PantheonCalculatorHistoryDialog* _tmp6_;
	PantheonCalculatorHistoryDialog* _tmp7_;
#line 790 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 790 "../src/MainWindow.vala"
	g_return_if_fail (button != NULL);
#line 791 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 791 "../src/MainWindow.vala"
	self->priv->position = gtk_editable_get_position ((GtkEditable*) _tmp0_);
#line 793 "../src/MainWindow.vala"
	_tmp1_ = self->priv->history;
#line 793 "../src/MainWindow.vala"
	_tmp2_ = _g_object_ref0 ((GtkWindow*) self);
#line 793 "../src/MainWindow.vala"
	_tmp3_ = pantheon_calculator_history_dialog_new (_tmp1_);
#line 793 "../src/MainWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp2_);
#line 793 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 793 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 793 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->history_dialog);
#line 793 "../src/MainWindow.vala"
	self->priv->history_dialog = _tmp3_;
#line 796 "../src/MainWindow.vala"
	_tmp4_ = self->priv->history_dialog;
#line 796 "../src/MainWindow.vala"
	gtk_window_present ((GtkWindow*) _tmp4_);
#line 798 "../src/MainWindow.vala"
	_tmp5_ = self->priv->history_dialog;
#line 798 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp5_, "added", (GCallback) _pantheon_calculator_main_window_history_added_pantheon_calculator_history_dialog_added, self, 0);
#line 799 "../src/MainWindow.vala"
	_tmp6_ = self->priv->history_dialog;
#line 799 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp6_, "clear-history", (GCallback) ___lambda35__pantheon_calculator_history_dialog_clear_history, self, 0);
#line 805 "../src/MainWindow.vala"
	_tmp7_ = self->priv->history_dialog;
#line 805 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp7_, "hide", (GCallback) ___lambda37__gtk_widget_hide, self, 0);
#line 2917 "MainWindow.c"
}

static void
pantheon_calculator_main_window_update_history_dialog (PantheonCalculatorMainWindow* self,
                                                       PantheonCalculatorMainWindowHistory* entry)
{
	PantheonCalculatorHistoryDialog* _tmp0_;
#line 810 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 810 "../src/MainWindow.vala"
	g_return_if_fail (entry != NULL);
#line 811 "../src/MainWindow.vala"
	_tmp0_ = self->priv->history_dialog;
#line 811 "../src/MainWindow.vala"
	if (_tmp0_ != NULL) {
#line 2933 "MainWindow.c"
		PantheonCalculatorHistoryDialog* _tmp1_;
		PantheonCalculatorMainWindowHistory _tmp2_;
#line 812 "../src/MainWindow.vala"
		_tmp1_ = self->priv->history_dialog;
#line 812 "../src/MainWindow.vala"
		_tmp2_ = *entry;
#line 812 "../src/MainWindow.vala"
		pantheon_calculator_history_dialog_append (_tmp1_, &_tmp2_);
#line 2942 "MainWindow.c"
	}
}

static void
pantheon_calculator_main_window_history_added (PantheonCalculatorMainWindow* self,
                                               const gchar* input)
{
	gint cursor_position = 0;
	GtkEntry* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkEntry* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
#line 816 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 816 "../src/MainWindow.vala"
	g_return_if_fail (input != NULL);
#line 817 "../src/MainWindow.vala"
	_tmp0_ = self->priv->entry;
#line 817 "../src/MainWindow.vala"
	g_object_get ((GtkEditable*) _tmp0_, "cursor-position", &_tmp1_, NULL);
#line 817 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 817 "../src/MainWindow.vala"
	cursor_position = _tmp2_;
#line 818 "../src/MainWindow.vala"
	_tmp3_ = self->priv->entry;
#line 818 "../src/MainWindow.vala"
	gtk_editable_insert_text ((GtkEditable*) _tmp3_, input, -1, &cursor_position);
#line 819 "../src/MainWindow.vala"
	_tmp4_ = strlen (input);
#line 819 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 819 "../src/MainWindow.vala"
	self->priv->position = self->priv->position + _tmp5_;
#line 820 "../src/MainWindow.vala"
	_tmp6_ = self->priv->entry;
#line 820 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 821 "../src/MainWindow.vala"
	_tmp7_ = self->priv->entry;
#line 821 "../src/MainWindow.vala"
	gtk_editable_set_position ((GtkEditable*) _tmp7_, self->priv->position);
#line 2989 "MainWindow.c"
}

static void
pantheon_calculator_main_window_remove_error (PantheonCalculatorMainWindow* self)
{
	GtkInfoBar* _tmp0_;
#line 824 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 825 "../src/MainWindow.vala"
	_tmp0_ = self->priv->infobar;
#line 825 "../src/MainWindow.vala"
	gtk_info_bar_set_revealed (_tmp0_, FALSE);
#line 3002 "MainWindow.c"
}

static void
pantheon_calculator_main_window_replace_text (PantheonCalculatorMainWindow* self,
                                              const gchar* new_text,
                                              gint new_text_length,
                                              gint* position)
{
	gchar* replacement_text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 831 "../src/MainWindow.vala"
	static GQuark _tmp2_label0 = 0;
#line 831 "../src/MainWindow.vala"
	static GQuark _tmp2_label1 = 0;
#line 831 "../src/MainWindow.vala"
	static GQuark _tmp2_label2 = 0;
#line 831 "../src/MainWindow.vala"
	static GQuark _tmp2_label3 = 0;
#line 3023 "MainWindow.c"
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
#line 828 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/MainWindow.vala"
	g_return_if_fail (new_text != NULL);
#line 829 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("");
#line 829 "../src/MainWindow.vala"
	replacement_text = _tmp0_;
#line 831 "../src/MainWindow.vala"
	_tmp1_ = new_text;
#line 831 "../src/MainWindow.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 831 "../src/MainWindow.vala"
	if ((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (".")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string (","))))) {
#line 831 "../src/MainWindow.vala"
		switch (0) {
#line 3042 "MainWindow.c"
			default:
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 834 "../src/MainWindow.vala"
				_tmp4_ = nl_langinfo (RADIXCHAR);
#line 834 "../src/MainWindow.vala"
				_tmp5_ = g_strdup (_tmp4_);
#line 834 "../src/MainWindow.vala"
				_g_free0 (replacement_text);
#line 834 "../src/MainWindow.vala"
				replacement_text = _tmp5_;
#line 835 "../src/MainWindow.vala"
				break;
#line 3057 "MainWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("/")))) {
#line 831 "../src/MainWindow.vala"
		switch (0) {
#line 3063 "MainWindow.c"
			default:
			{
				gchar* _tmp6_;
#line 837 "../src/MainWindow.vala"
				_tmp6_ = g_strdup ("÷");
#line 837 "../src/MainWindow.vala"
				_g_free0 (replacement_text);
#line 837 "../src/MainWindow.vala"
				replacement_text = _tmp6_;
#line 838 "../src/MainWindow.vala"
				break;
#line 3075 "MainWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("*")))) {
#line 831 "../src/MainWindow.vala"
		switch (0) {
#line 3081 "MainWindow.c"
			default:
			{
				gchar* _tmp7_;
#line 840 "../src/MainWindow.vala"
				_tmp7_ = g_strdup ("×");
#line 840 "../src/MainWindow.vala"
				_g_free0 (replacement_text);
#line 840 "../src/MainWindow.vala"
				replacement_text = _tmp7_;
#line 841 "../src/MainWindow.vala"
				break;
#line 3093 "MainWindow.c"
			}
		}
	}
#line 844 "../src/MainWindow.vala"
	_tmp9_ = replacement_text;
#line 844 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp9_, "") != 0) {
#line 3101 "MainWindow.c"
		const gchar* _tmp10_;
#line 844 "../src/MainWindow.vala"
		_tmp10_ = replacement_text;
#line 844 "../src/MainWindow.vala"
		_tmp8_ = g_strcmp0 (_tmp10_, new_text) != 0;
#line 3107 "MainWindow.c"
	} else {
#line 844 "../src/MainWindow.vala"
		_tmp8_ = FALSE;
#line 3111 "MainWindow.c"
	}
#line 844 "../src/MainWindow.vala"
	if (_tmp8_) {
#line 3115 "MainWindow.c"
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		GtkEntry* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		const gchar* _tmp16_;
		GtkEntry* _tmp17_;
		GtkEditable* _tmp18_;
#line 845 "../src/MainWindow.vala"
		_tmp11_ = self->priv->entry;
#line 845 "../src/MainWindow.vala"
		_tmp12_ = replacement_text;
#line 845 "../src/MainWindow.vala"
		_tmp13_ = self->priv->entry;
#line 845 "../src/MainWindow.vala"
		g_object_get ((GtkEditable*) _tmp13_, "cursor-position", &_tmp14_, NULL);
#line 845 "../src/MainWindow.vala"
		_tmp15_ = _tmp14_;
#line 845 "../src/MainWindow.vala"
		_tmp16_ = replacement_text;
#line 845 "../src/MainWindow.vala"
		gtk_editable_insert_text ((GtkEditable*) _tmp11_, _tmp12_, _tmp15_ + g_utf8_strlen (_tmp16_, (gssize) -1), position);
#line 846 "../src/MainWindow.vala"
		_tmp17_ = self->priv->entry;
#line 846 "../src/MainWindow.vala"
		_tmp18_ = gtk_editable_get_delegate ((GtkEditable*) _tmp17_);
#line 846 "../src/MainWindow.vala"
		g_signal_stop_emission_by_name ((void*) _tmp18_, "insert-text");
#line 3144 "MainWindow.c"
	}
#line 828 "../src/MainWindow.vala"
	_g_free0 (replacement_text);
#line 3148 "MainWindow.c"
}

void
pantheon_calculator_main_window_history_copy (const PantheonCalculatorMainWindowHistory* self,
                                              PantheonCalculatorMainWindowHistory* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 47 "../src/MainWindow.vala"
	_tmp0_ = (*self).exp;
#line 47 "../src/MainWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 47 "../src/MainWindow.vala"
	_g_free0 ((*dest).exp);
#line 47 "../src/MainWindow.vala"
	(*dest).exp = _tmp1_;
#line 47 "../src/MainWindow.vala"
	_tmp2_ = (*self).output;
#line 47 "../src/MainWindow.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 47 "../src/MainWindow.vala"
	_g_free0 ((*dest).output);
#line 47 "../src/MainWindow.vala"
	(*dest).output = _tmp3_;
#line 3175 "MainWindow.c"
}

void
pantheon_calculator_main_window_history_destroy (PantheonCalculatorMainWindowHistory* self)
{
#line 47 "../src/MainWindow.vala"
	_g_free0 ((*self).exp);
#line 47 "../src/MainWindow.vala"
	_g_free0 ((*self).output);
#line 3185 "MainWindow.c"
}

PantheonCalculatorMainWindowHistory*
pantheon_calculator_main_window_history_dup (const PantheonCalculatorMainWindowHistory* self)
{
	PantheonCalculatorMainWindowHistory* dup;
#line 47 "../src/MainWindow.vala"
	dup = g_new0 (PantheonCalculatorMainWindowHistory, 1);
#line 47 "../src/MainWindow.vala"
	pantheon_calculator_main_window_history_copy (self, dup);
#line 47 "../src/MainWindow.vala"
	return dup;
#line 3198 "MainWindow.c"
}

void
pantheon_calculator_main_window_history_free (PantheonCalculatorMainWindowHistory* self)
{
#line 47 "../src/MainWindow.vala"
	pantheon_calculator_main_window_history_destroy (self);
#line 47 "../src/MainWindow.vala"
	g_free (self);
#line 3208 "MainWindow.c"
}

static GType
pantheon_calculator_main_window_history_get_type_once (void)
{
	GType pantheon_calculator_main_window_history_type_id;
	pantheon_calculator_main_window_history_type_id = g_boxed_type_register_static ("PantheonCalculatorMainWindowHistory", (GBoxedCopyFunc) pantheon_calculator_main_window_history_dup, (GBoxedFreeFunc) pantheon_calculator_main_window_history_free);
	return pantheon_calculator_main_window_history_type_id;
}

GType
pantheon_calculator_main_window_history_get_type (void)
{
	static volatile gsize pantheon_calculator_main_window_history_type_id__once = 0;
	if (g_once_init_enter (&pantheon_calculator_main_window_history_type_id__once)) {
		GType pantheon_calculator_main_window_history_type_id;
		pantheon_calculator_main_window_history_type_id = pantheon_calculator_main_window_history_get_type_once ();
		g_once_init_leave (&pantheon_calculator_main_window_history_type_id__once, pantheon_calculator_main_window_history_type_id);
	}
	return pantheon_calculator_main_window_history_type_id__once;
}

static void
_pantheon_calculator_main_window_toggle_grid_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                        gpointer self)
{
#line 97 "../src/MainWindow.vala"
	pantheon_calculator_main_window_toggle_grid ((PantheonCalculatorMainWindow*) self, _sender);
#line 3237 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_show_history_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 104 "../src/MainWindow.vala"
	pantheon_calculator_main_window_show_history ((PantheonCalculatorMainWindow*) self, _sender);
#line 3246 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_remove_error_gtk_editable_changed (GtkEditable* _sender,
                                                                    gpointer self)
{
#line 472 "../src/MainWindow.vala"
	pantheon_calculator_main_window_remove_error ((PantheonCalculatorMainWindow*) self);
#line 3255 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_button_calc_clicked_gtk_entry_activate (GtkEntry* _sender,
                                                                         gpointer self)
{
#line 473 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_calc_clicked ((PantheonCalculatorMainWindow*) self);
#line 3264 "MainWindow.c"
}

static void
_pantheon_calculator_main_window_replace_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                        const gchar* text,
                                                                        gint length,
                                                                        gint* position,
                                                                        gpointer self)
{
#line 474 "../src/MainWindow.vala"
	pantheon_calculator_main_window_replace_text ((PantheonCalculatorMainWindow*) self, text, length, position);
#line 3276 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda38_ (PantheonCalculatorMainWindow* self)
{
#line 476 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_calc_clicked (self);
#line 3284 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda38__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 476 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda38_ ((PantheonCalculatorMainWindow*) self);
#line 3293 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda39_ (PantheonCalculatorMainWindow* self)
{
#line 477 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_del_clicked (self);
#line 3301 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda39__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 477 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda39_ ((PantheonCalculatorMainWindow*) self);
#line 3310 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda40_ (PantheonCalculatorMainWindow* self)
{
#line 478 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_ans_clicked (self);
#line 3318 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda40__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 478 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda40_ ((PantheonCalculatorMainWindow*) self);
#line 3327 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda41_ (PantheonCalculatorMainWindow* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
#line 481 "../src/MainWindow.vala"
	_tmp0_ = pantheon_calculator_main_window_number_to_string (self, self->priv->memory_value);
#line 481 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 481 "../src/MainWindow.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 481 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp2_);
#line 481 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 481 "../src/MainWindow.vala"
	g_action_group_activate_action ((GActionGroup*) self, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT, _tmp3_);
#line 481 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp3_);
#line 481 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 3353 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda41__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 480 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda41_ ((PantheonCalculatorMainWindow*) self);
#line 3362 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda42_ (PantheonCalculatorMainWindow* self)
{
#line 484 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_memory_store_clicked (self);
#line 3370 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda42__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 484 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda42_ ((PantheonCalculatorMainWindow*) self);
#line 3379 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda43_ (PantheonCalculatorMainWindow* self)
{
#line 485 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_memory_add_clicked (self);
#line 3387 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda43__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 485 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda43_ ((PantheonCalculatorMainWindow*) self);
#line 3396 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda44_ (PantheonCalculatorMainWindow* self)
{
#line 486 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_memory_subtract_clicked (self);
#line 3404 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda44__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 486 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda44_ ((PantheonCalculatorMainWindow*) self);
#line 3413 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda45_ (PantheonCalculatorMainWindow* self)
{
#line 487 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_memory_clear_clicked (self);
#line 3421 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda45__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 487 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda45_ ((PantheonCalculatorMainWindow*) self);
#line 3430 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda46_ (PantheonCalculatorMainWindow* self)
{
#line 488 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_gt_clicked (self);
#line 3438 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda46__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 488 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda46_ ((PantheonCalculatorMainWindow*) self);
#line 3447 "MainWindow.c"
}

static void
_pantheon_calculator_main_window___lambda47_ (PantheonCalculatorMainWindow* self)
{
#line 489 "../src/MainWindow.vala"
	pantheon_calculator_main_window_button_reciprocal_clicked (self);
#line 3455 "MainWindow.c"
}

static void
__pantheon_calculator_main_window___lambda47__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 489 "../src/MainWindow.vala"
	_pantheon_calculator_main_window___lambda47_ ((PantheonCalculatorMainWindow*) self);
#line 3464 "MainWindow.c"
}

static GObject *
pantheon_calculator_main_window_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonCalculatorMainWindow * self;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GtkApplication* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	GtkApplication* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkApplication* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GSettings* _tmp18_;
	PantheonCalculatorCoreEvaluation* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkToggleButton* _tmp22_ = NULL;
	GtkToggleButton* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkButton* _tmp26_ = NULL;
	GtkButton* _tmp27_;
	GtkHeaderBar* headerbar = NULL;
	GtkLabel* _tmp28_;
	GtkHeaderBar* _tmp29_ = NULL;
	GtkHeaderBar* _tmp30_;
	GtkToggleButton* _tmp31_;
	GtkHeaderBar* _tmp32_;
	GtkButton* _tmp33_;
	GtkHeaderBar* _tmp34_;
	GtkHeaderBar* _tmp35_;
	GtkEntry* _tmp36_ = NULL;
	GtkEntry* _tmp37_;
	gchar* _tmp38_;
	PantheonCalculatorButton* _tmp39_ = NULL;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	gchar* _tmp42_;
	PantheonCalculatorButton* _tmp43_ = NULL;
	gchar* _tmp44_;
	PantheonCalculatorButton* _tmp45_ = NULL;
	PantheonCalculatorButton* button_clr = NULL;
	gchar* _tmp46_;
	PantheonCalculatorButton* _tmp47_ = NULL;
	PantheonCalculatorButton* _tmp48_;
	GtkApplication* _tmp49_;
	PantheonCalculatorButton* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar** _tmp53_;
	gchar** _tmp54_;
	gchar** _tmp55_;
	gint _tmp55__length1;
	gchar* _tmp56_;
	gchar* _tmp57_;
	PantheonCalculatorButton* _tmp58_;
	PantheonCalculatorButton* button_add = NULL;
	gchar* _tmp59_;
	GVariant* _tmp60_;
	gchar* _tmp61_;
	PantheonCalculatorButton* _tmp62_ = NULL;
	PantheonCalculatorButton* _tmp63_;
	PantheonCalculatorButton* button_sub = NULL;
	gchar* _tmp64_;
	GVariant* _tmp65_;
	gchar* _tmp66_;
	PantheonCalculatorButton* _tmp67_ = NULL;
	PantheonCalculatorButton* _tmp68_;
	PantheonCalculatorButton* button_mult = NULL;
	gchar* _tmp69_;
	GVariant* _tmp70_;
	gchar* _tmp71_;
	PantheonCalculatorButton* _tmp72_ = NULL;
	PantheonCalculatorButton* _tmp73_;
	PantheonCalculatorButton* button_div = NULL;
	gchar* _tmp74_;
	GVariant* _tmp75_;
	gchar* _tmp76_;
	PantheonCalculatorButton* _tmp77_ = NULL;
	PantheonCalculatorButton* _tmp78_;
	PantheonCalculatorButton* button_0 = NULL;
	gchar* _tmp79_;
	GVariant* _tmp80_;
	PantheonCalculatorButton* _tmp81_ = NULL;
	PantheonCalculatorButton* button_point = NULL;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	const gchar* _tmp84_;
	GVariant* _tmp85_;
	PantheonCalculatorButton* _tmp86_ = NULL;
	PantheonCalculatorButton* button_percent = NULL;
	gchar* _tmp87_;
	GVariant* _tmp88_;
	gchar* _tmp89_;
	PantheonCalculatorButton* _tmp90_ = NULL;
	PantheonCalculatorButton* button_1 = NULL;
	gchar* _tmp91_;
	GVariant* _tmp92_;
	PantheonCalculatorButton* _tmp93_ = NULL;
	PantheonCalculatorButton* button_2 = NULL;
	gchar* _tmp94_;
	GVariant* _tmp95_;
	PantheonCalculatorButton* _tmp96_ = NULL;
	PantheonCalculatorButton* button_3 = NULL;
	gchar* _tmp97_;
	GVariant* _tmp98_;
	PantheonCalculatorButton* _tmp99_ = NULL;
	PantheonCalculatorButton* button_4 = NULL;
	gchar* _tmp100_;
	GVariant* _tmp101_;
	PantheonCalculatorButton* _tmp102_ = NULL;
	PantheonCalculatorButton* button_5 = NULL;
	gchar* _tmp103_;
	GVariant* _tmp104_;
	PantheonCalculatorButton* _tmp105_ = NULL;
	PantheonCalculatorButton* button_6 = NULL;
	gchar* _tmp106_;
	GVariant* _tmp107_;
	PantheonCalculatorButton* _tmp108_ = NULL;
	PantheonCalculatorButton* button_7 = NULL;
	gchar* _tmp109_;
	GVariant* _tmp110_;
	PantheonCalculatorButton* _tmp111_ = NULL;
	PantheonCalculatorButton* button_8 = NULL;
	gchar* _tmp112_;
	GVariant* _tmp113_;
	PantheonCalculatorButton* _tmp114_ = NULL;
	PantheonCalculatorButton* button_9 = NULL;
	gchar* _tmp115_;
	GVariant* _tmp116_;
	PantheonCalculatorButton* _tmp117_ = NULL;
	GtkGrid* basic_grid = NULL;
	GtkGrid* _tmp118_ = NULL;
	GtkGrid* _tmp119_;
	GtkEntry* _tmp120_;
	GtkGrid* _tmp121_;
	PantheonCalculatorButton* _tmp122_;
	GtkGrid* _tmp123_;
	GtkButton* _tmp124_;
	GtkGrid* _tmp125_;
	PantheonCalculatorButton* _tmp126_;
	GtkGrid* _tmp127_;
	PantheonCalculatorButton* _tmp128_;
	GtkGrid* _tmp129_;
	PantheonCalculatorButton* _tmp130_;
	GtkGrid* _tmp131_;
	PantheonCalculatorButton* _tmp132_;
	GtkGrid* _tmp133_;
	PantheonCalculatorButton* _tmp134_;
	GtkGrid* _tmp135_;
	PantheonCalculatorButton* _tmp136_;
	GtkGrid* _tmp137_;
	PantheonCalculatorButton* _tmp138_;
	GtkGrid* _tmp139_;
	PantheonCalculatorButton* _tmp140_;
	GtkGrid* _tmp141_;
	PantheonCalculatorButton* _tmp142_;
	GtkGrid* _tmp143_;
	PantheonCalculatorButton* _tmp144_;
	GtkGrid* _tmp145_;
	PantheonCalculatorButton* _tmp146_;
	GtkGrid* _tmp147_;
	PantheonCalculatorButton* _tmp148_;
	GtkGrid* _tmp149_;
	PantheonCalculatorButton* _tmp150_;
	GtkGrid* _tmp151_;
	PantheonCalculatorButton* _tmp152_;
	GtkGrid* _tmp153_;
	PantheonCalculatorButton* _tmp154_;
	GtkGrid* _tmp155_;
	PantheonCalculatorButton* _tmp156_;
	GtkGrid* _tmp157_;
	GtkButton* _tmp158_;
	GtkGrid* _tmp159_;
	GtkButton* _tmp160_;
	PantheonCalculatorButton* button_ms = NULL;
	gchar* _tmp161_;
	PantheonCalculatorButton* _tmp162_ = NULL;
	gchar* _tmp163_;
	PantheonCalculatorButton* _tmp164_ = NULL;
	PantheonCalculatorButton* button_m_add = NULL;
	gchar* _tmp165_;
	PantheonCalculatorButton* _tmp166_ = NULL;
	PantheonCalculatorButton* button_m_sub = NULL;
	gchar* _tmp167_;
	PantheonCalculatorButton* _tmp168_ = NULL;
	gchar* _tmp169_;
	PantheonCalculatorButton* _tmp170_ = NULL;
	gchar* _tmp171_;
	PantheonCalculatorButton* _tmp172_ = NULL;
	PantheonCalculatorButton* button_par_left = NULL;
	gchar* _tmp173_;
	GVariant* _tmp174_;
	gchar* _tmp175_;
	PantheonCalculatorButton* _tmp176_ = NULL;
	PantheonCalculatorButton* button_par_right = NULL;
	gchar* _tmp177_;
	GVariant* _tmp178_;
	gchar* _tmp179_;
	PantheonCalculatorButton* _tmp180_ = NULL;
	PantheonCalculatorButton* button_pow = NULL;
	gchar* _tmp181_;
	GVariant* _tmp182_;
	gchar* _tmp183_;
	PantheonCalculatorButton* _tmp184_ = NULL;
	PantheonCalculatorButton* button_sr = NULL;
	gchar* _tmp185_;
	GVariant* _tmp186_;
	gchar* _tmp187_;
	PantheonCalculatorButton* _tmp188_ = NULL;
	PantheonCalculatorButton* button_sin = NULL;
	gchar* _tmp189_;
	GVariant* _tmp190_;
	gchar* _tmp191_;
	PantheonCalculatorButton* _tmp192_ = NULL;
	PantheonCalculatorButton* button_sinh = NULL;
	gchar* _tmp193_;
	GVariant* _tmp194_;
	gchar* _tmp195_;
	PantheonCalculatorButton* _tmp196_ = NULL;
	PantheonCalculatorButton* button_cos = NULL;
	gchar* _tmp197_;
	GVariant* _tmp198_;
	gchar* _tmp199_;
	PantheonCalculatorButton* _tmp200_ = NULL;
	PantheonCalculatorButton* button_cosh = NULL;
	gchar* _tmp201_;
	GVariant* _tmp202_;
	gchar* _tmp203_;
	PantheonCalculatorButton* _tmp204_ = NULL;
	PantheonCalculatorButton* button_tan = NULL;
	gchar* _tmp205_;
	GVariant* _tmp206_;
	gchar* _tmp207_;
	PantheonCalculatorButton* _tmp208_ = NULL;
	PantheonCalculatorButton* button_tanh = NULL;
	gchar* _tmp209_;
	GVariant* _tmp210_;
	gchar* _tmp211_;
	PantheonCalculatorButton* _tmp212_ = NULL;
	PantheonCalculatorButton* button_pi = NULL;
	gchar* _tmp213_;
	GVariant* _tmp214_;
	gchar* _tmp215_;
	PantheonCalculatorButton* _tmp216_ = NULL;
	PantheonCalculatorButton* button_e = NULL;
	gchar* _tmp217_;
	GVariant* _tmp218_;
	gchar* _tmp219_;
	PantheonCalculatorButton* _tmp220_ = NULL;
	PantheonCalculatorButton* button_log = NULL;
	gchar* _tmp221_;
	GVariant* _tmp222_;
	gchar* _tmp223_;
	PantheonCalculatorButton* _tmp224_ = NULL;
	PantheonCalculatorButton* button_ln = NULL;
	gchar* _tmp225_;
	GVariant* _tmp226_;
	gchar* _tmp227_;
	PantheonCalculatorButton* _tmp228_ = NULL;
	PantheonCalculatorButton* button_asin = NULL;
	gchar* _tmp229_;
	GVariant* _tmp230_;
	gchar* _tmp231_;
	PantheonCalculatorButton* _tmp232_ = NULL;
	PantheonCalculatorButton* button_acos = NULL;
	gchar* _tmp233_;
	GVariant* _tmp234_;
	gchar* _tmp235_;
	PantheonCalculatorButton* _tmp236_ = NULL;
	PantheonCalculatorButton* button_atan = NULL;
	gchar* _tmp237_;
	GVariant* _tmp238_;
	gchar* _tmp239_;
	PantheonCalculatorButton* _tmp240_ = NULL;
	PantheonCalculatorButton* button_reciprocal = NULL;
	gchar* _tmp241_;
	PantheonCalculatorButton* _tmp242_ = NULL;
	GtkGrid* extended_grid = NULL;
	GtkGrid* _tmp243_ = NULL;
	GtkGrid* _tmp244_;
	PantheonCalculatorButton* _tmp245_;
	GtkGrid* _tmp246_;
	PantheonCalculatorButton* _tmp247_;
	GtkGrid* _tmp248_;
	PantheonCalculatorButton* _tmp249_;
	GtkGrid* _tmp250_;
	PantheonCalculatorButton* _tmp251_;
	GtkGrid* _tmp252_;
	GtkButton* _tmp253_;
	GtkGrid* _tmp254_;
	PantheonCalculatorButton* _tmp255_;
	GtkGrid* _tmp256_;
	PantheonCalculatorButton* _tmp257_;
	GtkGrid* _tmp258_;
	PantheonCalculatorButton* _tmp259_;
	GtkGrid* _tmp260_;
	PantheonCalculatorButton* _tmp261_;
	GtkGrid* _tmp262_;
	PantheonCalculatorButton* _tmp263_;
	GtkGrid* _tmp264_;
	PantheonCalculatorButton* _tmp265_;
	GtkGrid* _tmp266_;
	PantheonCalculatorButton* _tmp267_;
	GtkGrid* _tmp268_;
	PantheonCalculatorButton* _tmp269_;
	GtkGrid* _tmp270_;
	PantheonCalculatorButton* _tmp271_;
	GtkGrid* _tmp272_;
	PantheonCalculatorButton* _tmp273_;
	GtkGrid* _tmp274_;
	PantheonCalculatorButton* _tmp275_;
	GtkGrid* _tmp276_;
	GtkButton* _tmp277_;
	GtkGrid* _tmp278_;
	PantheonCalculatorButton* _tmp279_;
	GtkGrid* _tmp280_;
	PantheonCalculatorButton* _tmp281_;
	GtkGrid* _tmp282_;
	PantheonCalculatorButton* _tmp283_;
	GtkGrid* _tmp284_;
	GtkButton* _tmp285_;
	GtkGrid* _tmp286_;
	PantheonCalculatorButton* _tmp287_;
	GtkGrid* _tmp288_;
	PantheonCalculatorButton* _tmp289_;
	GtkGrid* _tmp290_;
	PantheonCalculatorButton* _tmp291_;
	GtkGrid* _tmp292_;
	GtkWidget* _tmp293_;
	GtkRevealer* _tmp294_ = NULL;
	GtkBox* main_grid = NULL;
	GtkBox* _tmp295_ = NULL;
	GtkBox* _tmp296_;
	GtkGrid* _tmp297_;
	GtkBox* _tmp298_;
	GtkRevealer* _tmp299_;
	GtkLabel* _tmp300_;
	GtkInfoBar* _tmp301_ = NULL;
	GtkInfoBar* _tmp302_;
	GtkLabel* _tmp303_;
	GtkBox* global_box = NULL;
	GtkBox* _tmp304_;
	GtkBox* _tmp305_;
	GtkInfoBar* _tmp306_;
	GtkBox* _tmp307_;
	GtkBox* _tmp308_;
	GtkBox* _tmp309_;
	GtkHeaderBar* _tmp310_;
	GtkEntry* _tmp311_;
	GtkEntry* _tmp312_;
	GtkEntry* _tmp313_;
	GtkEntry* _tmp314_;
	GtkEditable* _tmp315_;
	GtkButton* _tmp316_;
	GtkButton* _tmp317_;
	GtkButton* _tmp318_;
	GtkButton* _tmp319_;
	PantheonCalculatorButton* _tmp320_;
	PantheonCalculatorButton* _tmp321_;
	PantheonCalculatorButton* _tmp322_;
	GtkButton* _tmp323_;
	GtkButton* _tmp324_;
	PantheonCalculatorButton* _tmp325_;
	GSettings* _tmp326_;
	GtkToggleButton* _tmp327_;
	GtkApplication* _tmp328_;
	GList* _tmp329_;
#line 75 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (pantheon_calculator_main_window_parent_class);
#line 75 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, PantheonCalculatorMainWindow);
#line 76 "../src/MainWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) self, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_ENTRIES), self);
#line 78 "../src/MainWindow.vala"
	_tmp0_ = g_application_get_default ();
#line 78 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 78 "../src/MainWindow.vala"
	application_instance = _tmp1_;
#line 79 "../src/MainWindow.vala"
	_tmp2_ = application_instance;
#line 79 "../src/MainWindow.vala"
	_tmp3_ = g_strdup ("Escape");
#line 79 "../src/MainWindow.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 79 "../src/MainWindow.vala"
	_tmp4_[0] = _tmp3_;
#line 79 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/MainWindow.vala"
	_tmp5__length1 = 1;
#line 79 "../src/MainWindow.vala"
	gtk_application_set_accels_for_action (_tmp2_, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_CLEAR, _tmp5_);
#line 79 "../src/MainWindow.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 80 "../src/MainWindow.vala"
	_tmp6_ = application_instance;
#line 80 "../src/MainWindow.vala"
	_tmp7_ = g_strdup ("<Control>z");
#line 80 "../src/MainWindow.vala"
	_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 80 "../src/MainWindow.vala"
	_tmp8_[0] = _tmp7_;
#line 80 "../src/MainWindow.vala"
	_tmp9_ = _tmp8_;
#line 80 "../src/MainWindow.vala"
	_tmp9__length1 = 1;
#line 80 "../src/MainWindow.vala"
	gtk_application_set_accels_for_action (_tmp6_, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_UNDO, _tmp9_);
#line 80 "../src/MainWindow.vala"
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/MainWindow.vala"
	_tmp10_ = application_instance;
#line 81 "../src/MainWindow.vala"
	_tmp11_ = g_strdup ("<Control>c");
#line 81 "../src/MainWindow.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 81 "../src/MainWindow.vala"
	_tmp12_[0] = _tmp11_;
#line 81 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 81 "../src/MainWindow.vala"
	_tmp13__length1 = 1;
#line 81 "../src/MainWindow.vala"
	gtk_application_set_accels_for_action (_tmp10_, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_COPY, _tmp13_);
#line 81 "../src/MainWindow.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/MainWindow.vala"
	_tmp14_ = application_instance;
#line 82 "../src/MainWindow.vala"
	_tmp15_ = g_strdup ("<Control>v");
#line 82 "../src/MainWindow.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 82 "../src/MainWindow.vala"
	_tmp16_[0] = _tmp15_;
#line 82 "../src/MainWindow.vala"
	_tmp17_ = _tmp16_;
#line 82 "../src/MainWindow.vala"
	_tmp17__length1 = 1;
#line 82 "../src/MainWindow.vala"
	gtk_application_set_accels_for_action (_tmp14_, PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PASTE, _tmp17_);
#line 82 "../src/MainWindow.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/MainWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 85 "../src/MainWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Calculator"));
#line 87 "../src/MainWindow.vala"
	_tmp18_ = pantheon_calculator_main_window_settings;
#line 87 "../src/MainWindow.vala"
	self->priv->decimal_places = g_settings_get_int (_tmp18_, "decimal-places");
#line 89 "../src/MainWindow.vala"
	_tmp19_ = pantheon_calculator_core_evaluation_new ();
#line 89 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->eval);
#line 89 "../src/MainWindow.vala"
	self->priv->eval = _tmp19_;
#line 91 "../src/MainWindow.vala"
	(self->priv->history == NULL) ? NULL : (self->priv->history = (_g_list_free__pantheon_calculator_main_window_history_free0_ (self->priv->history), NULL));
#line 91 "../src/MainWindow.vala"
	self->priv->history = NULL;
#line 92 "../src/MainWindow.vala"
	self->priv->position = 0;
#line 93 "../src/MainWindow.vala"
	_tmp20_ = g_strdup ("pane-hide-symbolic");
#line 93 "../src/MainWindow.vala"
	_tmp21_ = g_strdup (_ ("Show extended functionality"));
#line 93 "../src/MainWindow.vala"
	_tmp22_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 93 "../src/MainWindow.vala"
	gtk_button_set_icon_name ((GtkButton*) _tmp22_, _tmp20_);
#line 93 "../src/MainWindow.vala"
	_g_free0 (_tmp20_);
#line 93 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _tmp21_);
#line 93 "../src/MainWindow.vala"
	_g_free0 (_tmp21_);
#line 93 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp22_);
#line 93 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_extended);
#line 93 "../src/MainWindow.vala"
	self->priv->button_extended = _tmp22_;
#line 97 "../src/MainWindow.vala"
	_tmp23_ = self->priv->button_extended;
#line 97 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp23_, "toggled", (GCallback) _pantheon_calculator_main_window_toggle_grid_gtk_toggle_button_toggled, self, 0);
#line 99 "../src/MainWindow.vala"
	_tmp24_ = g_strdup ("document-open-recent-symbolic");
#line 99 "../src/MainWindow.vala"
	_tmp25_ = g_strdup (_ ("History"));
#line 99 "../src/MainWindow.vala"
	_tmp26_ = (GtkButton*) gtk_button_new ();
#line 99 "../src/MainWindow.vala"
	gtk_button_set_icon_name (_tmp26_, _tmp24_);
#line 99 "../src/MainWindow.vala"
	_g_free0 (_tmp24_);
#line 99 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp26_, _tmp25_);
#line 99 "../src/MainWindow.vala"
	_g_free0 (_tmp25_);
#line 99 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, FALSE);
#line 99 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp26_);
#line 99 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_history);
#line 99 "../src/MainWindow.vala"
	self->priv->button_history = _tmp26_;
#line 104 "../src/MainWindow.vala"
	_tmp27_ = self->priv->button_history;
#line 104 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp27_, "clicked", (GCallback) _pantheon_calculator_main_window_show_history_gtk_button_clicked, self, 0);
#line 106 "../src/MainWindow.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
#line 106 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp28_);
#line 106 "../src/MainWindow.vala"
	_tmp29_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 106 "../src/MainWindow.vala"
	gtk_header_bar_set_show_title_buttons (_tmp29_, TRUE);
#line 106 "../src/MainWindow.vala"
	gtk_header_bar_set_title_widget (_tmp29_, (GtkWidget*) _tmp28_);
#line 106 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp28_);
#line 106 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp29_);
#line 106 "../src/MainWindow.vala"
	headerbar = _tmp29_;
#line 110 "../src/MainWindow.vala"
	_tmp30_ = headerbar;
#line 110 "../src/MainWindow.vala"
	_tmp31_ = self->priv->button_extended;
#line 110 "../src/MainWindow.vala"
	gtk_header_bar_pack_end (_tmp30_, (GtkWidget*) _tmp31_);
#line 111 "../src/MainWindow.vala"
	_tmp32_ = headerbar;
#line 111 "../src/MainWindow.vala"
	_tmp33_ = self->priv->button_history;
#line 111 "../src/MainWindow.vala"
	gtk_header_bar_pack_end (_tmp32_, (GtkWidget*) _tmp33_);
#line 112 "../src/MainWindow.vala"
	_tmp34_ = headerbar;
#line 112 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp34_, GRANITE_STYLE_CLASS_DEFAULT_DECORATION);
#line 113 "../src/MainWindow.vala"
	_tmp35_ = headerbar;
#line 113 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp35_, GRANITE_STYLE_CLASS_FLAT);
#line 115 "../src/MainWindow.vala"
	_tmp36_ = (GtkEntry*) gtk_entry_new ();
#line 115 "../src/MainWindow.vala"
	g_object_set ((GtkEditable*) _tmp36_, "xalign", (gfloat) 1, NULL);
#line 115 "../src/MainWindow.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp36_, TRUE);
#line 115 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_FILL);
#line 115 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp36_);
#line 115 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->entry);
#line 115 "../src/MainWindow.vala"
	self->priv->entry = _tmp36_;
#line 120 "../src/MainWindow.vala"
	_tmp37_ = self->priv->entry;
#line 120 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp37_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 122 "../src/MainWindow.vala"
	_tmp38_ = g_strdup (_ ("Calculate Result"));
#line 122 "../src/MainWindow.vala"
	_tmp39_ = pantheon_calculator_button_new ("=");
#line 122 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp39_, _tmp38_);
#line 122 "../src/MainWindow.vala"
	_g_free0 (_tmp38_);
#line 122 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp39_);
#line 122 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_calc);
#line 122 "../src/MainWindow.vala"
	self->priv->button_calc = (GtkButton*) _tmp39_;
#line 125 "../src/MainWindow.vala"
	_tmp40_ = self->priv->button_calc;
#line 125 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp40_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 126 "../src/MainWindow.vala"
	_tmp41_ = self->priv->button_calc;
#line 126 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp41_, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 128 "../src/MainWindow.vala"
	_tmp42_ = g_strdup (_ ("Insert last result"));
#line 128 "../src/MainWindow.vala"
	_tmp43_ = pantheon_calculator_button_new ("ANS");
#line 128 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp43_, FALSE);
#line 128 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp43_, _tmp42_);
#line 128 "../src/MainWindow.vala"
	_g_free0 (_tmp42_);
#line 128 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp43_);
#line 128 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_ans);
#line 128 "../src/MainWindow.vala"
	self->priv->button_ans = (GtkButton*) _tmp43_;
#line 133 "../src/MainWindow.vala"
	_tmp44_ = g_strdup (_ ("Backspace"));
#line 133 "../src/MainWindow.vala"
	_tmp45_ = pantheon_calculator_button_new ("Del");
#line 133 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp45_, _tmp44_);
#line 133 "../src/MainWindow.vala"
	_g_free0 (_tmp44_);
#line 133 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp45_);
#line 133 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_del);
#line 133 "../src/MainWindow.vala"
	self->priv->button_del = (GtkButton*) _tmp45_;
#line 137 "../src/MainWindow.vala"
	_tmp46_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_CLEAR);
#line 137 "../src/MainWindow.vala"
	_tmp47_ = pantheon_calculator_button_new ("C");
#line 137 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp47_, _tmp46_);
#line 137 "../src/MainWindow.vala"
	_g_free0 (_tmp46_);
#line 137 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp47_);
#line 137 "../src/MainWindow.vala"
	button_clr = _tmp47_;
#line 140 "../src/MainWindow.vala"
	_tmp48_ = button_clr;
#line 140 "../src/MainWindow.vala"
	_tmp49_ = application_instance;
#line 140 "../src/MainWindow.vala"
	_tmp50_ = button_clr;
#line 140 "../src/MainWindow.vala"
	_tmp51_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp50_);
#line 140 "../src/MainWindow.vala"
	_tmp52_ = _tmp51_;
#line 140 "../src/MainWindow.vala"
	_tmp54_ = _tmp53_ = gtk_application_get_accels_for_action (_tmp49_, _tmp52_);
#line 140 "../src/MainWindow.vala"
	_tmp55_ = _tmp54_;
#line 140 "../src/MainWindow.vala"
	_tmp55__length1 = _vala_array_length (_tmp53_);
#line 140 "../src/MainWindow.vala"
	_tmp56_ = granite_markup_accel_tooltip (_tmp55_, (gint) _vala_array_length (_tmp53_), _ ("Clear entry"));
#line 140 "../src/MainWindow.vala"
	_tmp57_ = _tmp56_;
#line 140 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp48_, _tmp57_);
#line 140 "../src/MainWindow.vala"
	_g_free0 (_tmp57_);
#line 140 "../src/MainWindow.vala"
	_tmp55_ = (_vala_array_free (_tmp55_, _tmp55__length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/MainWindow.vala"
	_tmp58_ = button_clr;
#line 144 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp58_, GRANITE_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 146 "../src/MainWindow.vala"
	_tmp59_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 146 "../src/MainWindow.vala"
	_tmp60_ = g_variant_new_string ("+");
#line 146 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp60_);
#line 146 "../src/MainWindow.vala"
	_tmp61_ = g_strdup (_ ("Add"));
#line 146 "../src/MainWindow.vala"
	_tmp62_ = pantheon_calculator_button_new (" + ");
#line 146 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp62_, _tmp59_);
#line 146 "../src/MainWindow.vala"
	_g_free0 (_tmp59_);
#line 146 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp62_, "action-target", _tmp60_, NULL);
#line 146 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp60_);
#line 146 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp62_, _tmp61_);
#line 146 "../src/MainWindow.vala"
	_g_free0 (_tmp61_);
#line 146 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp62_);
#line 146 "../src/MainWindow.vala"
	button_add = _tmp62_;
#line 151 "../src/MainWindow.vala"
	_tmp63_ = button_add;
#line 151 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp63_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 153 "../src/MainWindow.vala"
	_tmp64_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 153 "../src/MainWindow.vala"
	_tmp65_ = g_variant_new_string ("-");
#line 153 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp65_);
#line 153 "../src/MainWindow.vala"
	_tmp66_ = g_strdup (_ ("Subtract"));
#line 153 "../src/MainWindow.vala"
	_tmp67_ = pantheon_calculator_button_new (" − ");
#line 153 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp67_, _tmp64_);
#line 153 "../src/MainWindow.vala"
	_g_free0 (_tmp64_);
#line 153 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp67_, "action-target", _tmp65_, NULL);
#line 153 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp65_);
#line 153 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp67_, _tmp66_);
#line 153 "../src/MainWindow.vala"
	_g_free0 (_tmp66_);
#line 153 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp67_);
#line 153 "../src/MainWindow.vala"
	button_sub = _tmp67_;
#line 158 "../src/MainWindow.vala"
	_tmp68_ = button_sub;
#line 158 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp68_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 160 "../src/MainWindow.vala"
	_tmp69_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 160 "../src/MainWindow.vala"
	_tmp70_ = g_variant_new_string ("×");
#line 160 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp70_);
#line 160 "../src/MainWindow.vala"
	_tmp71_ = g_strdup (_ ("Multiply"));
#line 160 "../src/MainWindow.vala"
	_tmp72_ = pantheon_calculator_button_new (" × ");
#line 160 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp72_, _tmp69_);
#line 160 "../src/MainWindow.vala"
	_g_free0 (_tmp69_);
#line 160 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp72_, "action-target", _tmp70_, NULL);
#line 160 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp70_);
#line 160 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp72_, _tmp71_);
#line 160 "../src/MainWindow.vala"
	_g_free0 (_tmp71_);
#line 160 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp72_);
#line 160 "../src/MainWindow.vala"
	button_mult = _tmp72_;
#line 165 "../src/MainWindow.vala"
	_tmp73_ = button_mult;
#line 165 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp73_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 167 "../src/MainWindow.vala"
	_tmp74_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 167 "../src/MainWindow.vala"
	_tmp75_ = g_variant_new_string ("÷");
#line 167 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp75_);
#line 167 "../src/MainWindow.vala"
	_tmp76_ = g_strdup (_ ("Divide"));
#line 167 "../src/MainWindow.vala"
	_tmp77_ = pantheon_calculator_button_new (" ÷ ");
#line 167 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp77_, _tmp74_);
#line 167 "../src/MainWindow.vala"
	_g_free0 (_tmp74_);
#line 167 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp77_, "action-target", _tmp75_, NULL);
#line 167 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp75_);
#line 167 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp77_, _tmp76_);
#line 167 "../src/MainWindow.vala"
	_g_free0 (_tmp76_);
#line 167 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp77_);
#line 167 "../src/MainWindow.vala"
	button_div = _tmp77_;
#line 172 "../src/MainWindow.vala"
	_tmp78_ = button_div;
#line 172 "../src/MainWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp78_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 174 "../src/MainWindow.vala"
	_tmp79_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 174 "../src/MainWindow.vala"
	_tmp80_ = g_variant_new_string ("0");
#line 174 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp80_);
#line 174 "../src/MainWindow.vala"
	_tmp81_ = pantheon_calculator_button_new ("0");
#line 174 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp81_, _tmp79_);
#line 174 "../src/MainWindow.vala"
	_g_free0 (_tmp79_);
#line 174 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp81_, "action-target", _tmp80_, NULL);
#line 174 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp80_);
#line 174 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp81_);
#line 174 "../src/MainWindow.vala"
	button_0 = _tmp81_;
#line 179 "../src/MainWindow.vala"
	_tmp82_ = nl_langinfo (RADIXCHAR);
#line 179 "../src/MainWindow.vala"
	_tmp83_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 179 "../src/MainWindow.vala"
	_tmp84_ = nl_langinfo (RADIXCHAR);
#line 179 "../src/MainWindow.vala"
	_tmp85_ = g_variant_new_string (_tmp84_);
#line 179 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp85_);
#line 179 "../src/MainWindow.vala"
	_tmp86_ = pantheon_calculator_button_new (_tmp82_);
#line 179 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp86_, _tmp83_);
#line 179 "../src/MainWindow.vala"
	_g_free0 (_tmp83_);
#line 179 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp86_, "action-target", _tmp85_, NULL);
#line 179 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp85_);
#line 179 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp86_);
#line 179 "../src/MainWindow.vala"
	button_point = _tmp86_;
#line 184 "../src/MainWindow.vala"
	_tmp87_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 184 "../src/MainWindow.vala"
	_tmp88_ = g_variant_new_string ("%");
#line 184 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp88_);
#line 184 "../src/MainWindow.vala"
	_tmp89_ = g_strdup (_ ("Percentage"));
#line 184 "../src/MainWindow.vala"
	_tmp90_ = pantheon_calculator_button_new ("%");
#line 184 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp90_, _tmp87_);
#line 184 "../src/MainWindow.vala"
	_g_free0 (_tmp87_);
#line 184 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp90_, "action-target", _tmp88_, NULL);
#line 184 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp88_);
#line 184 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp90_, _tmp89_);
#line 184 "../src/MainWindow.vala"
	_g_free0 (_tmp89_);
#line 184 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp90_);
#line 184 "../src/MainWindow.vala"
	button_percent = _tmp90_;
#line 190 "../src/MainWindow.vala"
	_tmp91_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 190 "../src/MainWindow.vala"
	_tmp92_ = g_variant_new_string ("1");
#line 190 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp92_);
#line 190 "../src/MainWindow.vala"
	_tmp93_ = pantheon_calculator_button_new ("1");
#line 190 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp93_, _tmp91_);
#line 190 "../src/MainWindow.vala"
	_g_free0 (_tmp91_);
#line 190 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp93_, "action-target", _tmp92_, NULL);
#line 190 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp92_);
#line 190 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp93_);
#line 190 "../src/MainWindow.vala"
	button_1 = _tmp93_;
#line 195 "../src/MainWindow.vala"
	_tmp94_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 195 "../src/MainWindow.vala"
	_tmp95_ = g_variant_new_string ("2");
#line 195 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp95_);
#line 195 "../src/MainWindow.vala"
	_tmp96_ = pantheon_calculator_button_new ("2");
#line 195 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp96_, _tmp94_);
#line 195 "../src/MainWindow.vala"
	_g_free0 (_tmp94_);
#line 195 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp96_, "action-target", _tmp95_, NULL);
#line 195 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp95_);
#line 195 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp96_);
#line 195 "../src/MainWindow.vala"
	button_2 = _tmp96_;
#line 200 "../src/MainWindow.vala"
	_tmp97_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 200 "../src/MainWindow.vala"
	_tmp98_ = g_variant_new_string ("3");
#line 200 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp98_);
#line 200 "../src/MainWindow.vala"
	_tmp99_ = pantheon_calculator_button_new ("3");
#line 200 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp99_, _tmp97_);
#line 200 "../src/MainWindow.vala"
	_g_free0 (_tmp97_);
#line 200 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp99_, "action-target", _tmp98_, NULL);
#line 200 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp98_);
#line 200 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp99_);
#line 200 "../src/MainWindow.vala"
	button_3 = _tmp99_;
#line 205 "../src/MainWindow.vala"
	_tmp100_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 205 "../src/MainWindow.vala"
	_tmp101_ = g_variant_new_string ("4");
#line 205 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp101_);
#line 205 "../src/MainWindow.vala"
	_tmp102_ = pantheon_calculator_button_new ("4");
#line 205 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp102_, _tmp100_);
#line 205 "../src/MainWindow.vala"
	_g_free0 (_tmp100_);
#line 205 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp102_, "action-target", _tmp101_, NULL);
#line 205 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp101_);
#line 205 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp102_);
#line 205 "../src/MainWindow.vala"
	button_4 = _tmp102_;
#line 210 "../src/MainWindow.vala"
	_tmp103_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 210 "../src/MainWindow.vala"
	_tmp104_ = g_variant_new_string ("5");
#line 210 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp104_);
#line 210 "../src/MainWindow.vala"
	_tmp105_ = pantheon_calculator_button_new ("5");
#line 210 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp105_, _tmp103_);
#line 210 "../src/MainWindow.vala"
	_g_free0 (_tmp103_);
#line 210 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp105_, "action-target", _tmp104_, NULL);
#line 210 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp104_);
#line 210 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp105_);
#line 210 "../src/MainWindow.vala"
	button_5 = _tmp105_;
#line 215 "../src/MainWindow.vala"
	_tmp106_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 215 "../src/MainWindow.vala"
	_tmp107_ = g_variant_new_string ("6");
#line 215 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp107_);
#line 215 "../src/MainWindow.vala"
	_tmp108_ = pantheon_calculator_button_new ("6");
#line 215 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp108_, _tmp106_);
#line 215 "../src/MainWindow.vala"
	_g_free0 (_tmp106_);
#line 215 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp108_, "action-target", _tmp107_, NULL);
#line 215 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp107_);
#line 215 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp108_);
#line 215 "../src/MainWindow.vala"
	button_6 = _tmp108_;
#line 220 "../src/MainWindow.vala"
	_tmp109_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 220 "../src/MainWindow.vala"
	_tmp110_ = g_variant_new_string ("7");
#line 220 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp110_);
#line 220 "../src/MainWindow.vala"
	_tmp111_ = pantheon_calculator_button_new ("7");
#line 220 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp111_, _tmp109_);
#line 220 "../src/MainWindow.vala"
	_g_free0 (_tmp109_);
#line 220 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp111_, "action-target", _tmp110_, NULL);
#line 220 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp110_);
#line 220 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp111_);
#line 220 "../src/MainWindow.vala"
	button_7 = _tmp111_;
#line 225 "../src/MainWindow.vala"
	_tmp112_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 225 "../src/MainWindow.vala"
	_tmp113_ = g_variant_new_string ("8");
#line 225 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp113_);
#line 225 "../src/MainWindow.vala"
	_tmp114_ = pantheon_calculator_button_new ("8");
#line 225 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp114_, _tmp112_);
#line 225 "../src/MainWindow.vala"
	_g_free0 (_tmp112_);
#line 225 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp114_, "action-target", _tmp113_, NULL);
#line 225 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp113_);
#line 225 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp114_);
#line 225 "../src/MainWindow.vala"
	button_8 = _tmp114_;
#line 230 "../src/MainWindow.vala"
	_tmp115_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 230 "../src/MainWindow.vala"
	_tmp116_ = g_variant_new_string ("9");
#line 230 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp116_);
#line 230 "../src/MainWindow.vala"
	_tmp117_ = pantheon_calculator_button_new ("9");
#line 230 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp117_, _tmp115_);
#line 230 "../src/MainWindow.vala"
	_g_free0 (_tmp115_);
#line 230 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp117_, "action-target", _tmp116_, NULL);
#line 230 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp116_);
#line 230 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp117_);
#line 230 "../src/MainWindow.vala"
	button_9 = _tmp117_;
#line 235 "../src/MainWindow.vala"
	_tmp118_ = (GtkGrid*) gtk_grid_new ();
#line 235 "../src/MainWindow.vala"
	gtk_grid_set_column_spacing (_tmp118_, 6);
#line 235 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp118_, 6);
#line 235 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp118_, 6);
#line 235 "../src/MainWindow.vala"
	gtk_grid_set_row_homogeneous (_tmp118_, TRUE);
#line 235 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp118_);
#line 235 "../src/MainWindow.vala"
	basic_grid = _tmp118_;
#line 242 "../src/MainWindow.vala"
	_tmp119_ = basic_grid;
#line 242 "../src/MainWindow.vala"
	_tmp120_ = self->priv->entry;
#line 242 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp119_, (GtkWidget*) _tmp120_, 0, 0, 4, 1);
#line 243 "../src/MainWindow.vala"
	_tmp121_ = basic_grid;
#line 243 "../src/MainWindow.vala"
	_tmp122_ = button_clr;
#line 243 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp121_, (GtkWidget*) _tmp122_, 0, 1, 1, 1);
#line 244 "../src/MainWindow.vala"
	_tmp123_ = basic_grid;
#line 244 "../src/MainWindow.vala"
	_tmp124_ = self->priv->button_del;
#line 244 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp123_, (GtkWidget*) _tmp124_, 1, 1, 1, 1);
#line 245 "../src/MainWindow.vala"
	_tmp125_ = basic_grid;
#line 245 "../src/MainWindow.vala"
	_tmp126_ = button_percent;
#line 245 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, 2, 1, 1, 1);
#line 246 "../src/MainWindow.vala"
	_tmp127_ = basic_grid;
#line 246 "../src/MainWindow.vala"
	_tmp128_ = button_div;
#line 246 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp127_, (GtkWidget*) _tmp128_, 3, 1, 1, 1);
#line 248 "../src/MainWindow.vala"
	_tmp129_ = basic_grid;
#line 248 "../src/MainWindow.vala"
	_tmp130_ = button_7;
#line 248 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, 0, 2, 1, 1);
#line 249 "../src/MainWindow.vala"
	_tmp131_ = basic_grid;
#line 249 "../src/MainWindow.vala"
	_tmp132_ = button_8;
#line 249 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp131_, (GtkWidget*) _tmp132_, 1, 2, 1, 1);
#line 250 "../src/MainWindow.vala"
	_tmp133_ = basic_grid;
#line 250 "../src/MainWindow.vala"
	_tmp134_ = button_9;
#line 250 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp133_, (GtkWidget*) _tmp134_, 2, 2, 1, 1);
#line 251 "../src/MainWindow.vala"
	_tmp135_ = basic_grid;
#line 251 "../src/MainWindow.vala"
	_tmp136_ = button_mult;
#line 251 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp135_, (GtkWidget*) _tmp136_, 3, 2, 1, 1);
#line 253 "../src/MainWindow.vala"
	_tmp137_ = basic_grid;
#line 253 "../src/MainWindow.vala"
	_tmp138_ = button_4;
#line 253 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp137_, (GtkWidget*) _tmp138_, 0, 3, 1, 1);
#line 254 "../src/MainWindow.vala"
	_tmp139_ = basic_grid;
#line 254 "../src/MainWindow.vala"
	_tmp140_ = button_5;
#line 254 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp139_, (GtkWidget*) _tmp140_, 1, 3, 1, 1);
#line 255 "../src/MainWindow.vala"
	_tmp141_ = basic_grid;
#line 255 "../src/MainWindow.vala"
	_tmp142_ = button_6;
#line 255 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp141_, (GtkWidget*) _tmp142_, 2, 3, 1, 1);
#line 256 "../src/MainWindow.vala"
	_tmp143_ = basic_grid;
#line 256 "../src/MainWindow.vala"
	_tmp144_ = button_sub;
#line 256 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp143_, (GtkWidget*) _tmp144_, 3, 3, 1, 1);
#line 258 "../src/MainWindow.vala"
	_tmp145_ = basic_grid;
#line 258 "../src/MainWindow.vala"
	_tmp146_ = button_1;
#line 258 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp145_, (GtkWidget*) _tmp146_, 0, 4, 1, 1);
#line 259 "../src/MainWindow.vala"
	_tmp147_ = basic_grid;
#line 259 "../src/MainWindow.vala"
	_tmp148_ = button_2;
#line 259 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp147_, (GtkWidget*) _tmp148_, 1, 4, 1, 1);
#line 260 "../src/MainWindow.vala"
	_tmp149_ = basic_grid;
#line 260 "../src/MainWindow.vala"
	_tmp150_ = button_3;
#line 260 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp149_, (GtkWidget*) _tmp150_, 2, 4, 1, 1);
#line 261 "../src/MainWindow.vala"
	_tmp151_ = basic_grid;
#line 261 "../src/MainWindow.vala"
	_tmp152_ = button_add;
#line 261 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp151_, (GtkWidget*) _tmp152_, 3, 4, 1, 1);
#line 263 "../src/MainWindow.vala"
	_tmp153_ = basic_grid;
#line 263 "../src/MainWindow.vala"
	_tmp154_ = button_0;
#line 263 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp153_, (GtkWidget*) _tmp154_, 0, 5, 1, 1);
#line 264 "../src/MainWindow.vala"
	_tmp155_ = basic_grid;
#line 264 "../src/MainWindow.vala"
	_tmp156_ = button_point;
#line 264 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp155_, (GtkWidget*) _tmp156_, 1, 5, 1, 1);
#line 265 "../src/MainWindow.vala"
	_tmp157_ = basic_grid;
#line 265 "../src/MainWindow.vala"
	_tmp158_ = self->priv->button_ans;
#line 265 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp157_, (GtkWidget*) _tmp158_, 2, 5, 1, 1);
#line 266 "../src/MainWindow.vala"
	_tmp159_ = basic_grid;
#line 266 "../src/MainWindow.vala"
	_tmp160_ = self->priv->button_calc;
#line 266 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp159_, (GtkWidget*) _tmp160_, 3, 5, 1, 1);
#line 268 "../src/MainWindow.vala"
	_tmp161_ = g_strdup (_ ("Set memory value"));
#line 268 "../src/MainWindow.vala"
	_tmp162_ = pantheon_calculator_button_new ("MS");
#line 268 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp162_, _tmp161_);
#line 268 "../src/MainWindow.vala"
	_g_free0 (_tmp161_);
#line 268 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp162_);
#line 268 "../src/MainWindow.vala"
	button_ms = _tmp162_;
#line 272 "../src/MainWindow.vala"
	_tmp163_ = g_strdup (_ ("Recall value from memory"));
#line 272 "../src/MainWindow.vala"
	_tmp164_ = pantheon_calculator_button_new ("MR");
#line 272 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp164_, FALSE);
#line 272 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp164_, _tmp163_);
#line 272 "../src/MainWindow.vala"
	_g_free0 (_tmp163_);
#line 272 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp164_);
#line 272 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_mr);
#line 272 "../src/MainWindow.vala"
	self->priv->button_mr = (GtkButton*) _tmp164_;
#line 277 "../src/MainWindow.vala"
	_tmp165_ = g_strdup (_ ("Add to stored value"));
#line 277 "../src/MainWindow.vala"
	_tmp166_ = pantheon_calculator_button_new ("M+");
#line 277 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp166_, _tmp165_);
#line 277 "../src/MainWindow.vala"
	_g_free0 (_tmp165_);
#line 277 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp166_);
#line 277 "../src/MainWindow.vala"
	button_m_add = _tmp166_;
#line 281 "../src/MainWindow.vala"
	_tmp167_ = g_strdup (_ ("Subtract from stored value"));
#line 281 "../src/MainWindow.vala"
	_tmp168_ = pantheon_calculator_button_new ("M−");
#line 281 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp168_, _tmp167_);
#line 281 "../src/MainWindow.vala"
	_g_free0 (_tmp167_);
#line 281 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp168_);
#line 281 "../src/MainWindow.vala"
	button_m_sub = _tmp168_;
#line 285 "../src/MainWindow.vala"
	_tmp169_ = g_strdup (_ ("Clear memory"));
#line 285 "../src/MainWindow.vala"
	_tmp170_ = pantheon_calculator_button_new ("MC");
#line 285 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp170_, FALSE);
#line 285 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp170_, _tmp169_);
#line 285 "../src/MainWindow.vala"
	_g_free0 (_tmp169_);
#line 285 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp170_);
#line 285 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_mc);
#line 285 "../src/MainWindow.vala"
	self->priv->button_mc = (GtkButton*) _tmp170_;
#line 290 "../src/MainWindow.vala"
	_tmp171_ = g_strdup (_ ("Grand Total"));
#line 290 "../src/MainWindow.vala"
	_tmp172_ = pantheon_calculator_button_new ("GT");
#line 290 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp172_, FALSE);
#line 290 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp172_, _tmp171_);
#line 290 "../src/MainWindow.vala"
	_g_free0 (_tmp171_);
#line 290 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp172_);
#line 290 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_gt);
#line 290 "../src/MainWindow.vala"
	self->priv->button_gt = (GtkButton*) _tmp172_;
#line 295 "../src/MainWindow.vala"
	_tmp173_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 295 "../src/MainWindow.vala"
	_tmp174_ = g_variant_new_string ("(");
#line 295 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp174_);
#line 295 "../src/MainWindow.vala"
	_tmp175_ = g_strdup (_ ("Start Group"));
#line 295 "../src/MainWindow.vala"
	_tmp176_ = pantheon_calculator_button_new ("(");
#line 295 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp176_, _tmp173_);
#line 295 "../src/MainWindow.vala"
	_g_free0 (_tmp173_);
#line 295 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp176_, "action-target", _tmp174_, NULL);
#line 295 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp174_);
#line 295 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp176_, _tmp175_);
#line 295 "../src/MainWindow.vala"
	_g_free0 (_tmp175_);
#line 295 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp176_);
#line 295 "../src/MainWindow.vala"
	button_par_left = _tmp176_;
#line 301 "../src/MainWindow.vala"
	_tmp177_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 301 "../src/MainWindow.vala"
	_tmp178_ = g_variant_new_string (")");
#line 301 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp178_);
#line 301 "../src/MainWindow.vala"
	_tmp179_ = g_strdup (_ ("End Group"));
#line 301 "../src/MainWindow.vala"
	_tmp180_ = pantheon_calculator_button_new (")");
#line 301 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp180_, _tmp177_);
#line 301 "../src/MainWindow.vala"
	_g_free0 (_tmp177_);
#line 301 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp180_, "action-target", _tmp178_, NULL);
#line 301 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp178_);
#line 301 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp180_, _tmp179_);
#line 301 "../src/MainWindow.vala"
	_g_free0 (_tmp179_);
#line 301 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp180_);
#line 301 "../src/MainWindow.vala"
	button_par_right = _tmp180_;
#line 307 "../src/MainWindow.vala"
	_tmp181_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 307 "../src/MainWindow.vala"
	_tmp182_ = g_variant_new_string ("^");
#line 307 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp182_);
#line 307 "../src/MainWindow.vala"
	_tmp183_ = g_strdup (_ ("Exponent"));
#line 307 "../src/MainWindow.vala"
	_tmp184_ = pantheon_calculator_button_new ("x<sup>y</sup>");
#line 307 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp184_, _tmp181_);
#line 307 "../src/MainWindow.vala"
	_g_free0 (_tmp181_);
#line 307 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp184_, "action-target", _tmp182_, NULL);
#line 307 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp182_);
#line 307 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp184_, _tmp183_);
#line 307 "../src/MainWindow.vala"
	_g_free0 (_tmp183_);
#line 307 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp184_);
#line 307 "../src/MainWindow.vala"
	button_pow = _tmp184_;
#line 313 "../src/MainWindow.vala"
	_tmp185_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 313 "../src/MainWindow.vala"
	_tmp186_ = g_variant_new_string ("√");
#line 313 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp186_);
#line 313 "../src/MainWindow.vala"
	_tmp187_ = g_strdup (_ ("Root"));
#line 313 "../src/MainWindow.vala"
	_tmp188_ = pantheon_calculator_button_new ("√");
#line 313 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp188_, _tmp185_);
#line 313 "../src/MainWindow.vala"
	_g_free0 (_tmp185_);
#line 313 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp188_, "action-target", _tmp186_, NULL);
#line 313 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp186_);
#line 313 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp188_, _tmp187_);
#line 313 "../src/MainWindow.vala"
	_g_free0 (_tmp187_);
#line 313 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp188_);
#line 313 "../src/MainWindow.vala"
	button_sr = _tmp188_;
#line 319 "../src/MainWindow.vala"
	_tmp189_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 319 "../src/MainWindow.vala"
	_tmp190_ = g_variant_new_string ("sin");
#line 319 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp190_);
#line 319 "../src/MainWindow.vala"
	_tmp191_ = g_strdup (_ ("Sine"));
#line 319 "../src/MainWindow.vala"
	_tmp192_ = pantheon_calculator_button_new ("sin");
#line 319 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp192_, _tmp189_);
#line 319 "../src/MainWindow.vala"
	_g_free0 (_tmp189_);
#line 319 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp192_, "action-target", _tmp190_, NULL);
#line 319 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp190_);
#line 319 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp192_, _tmp191_);
#line 319 "../src/MainWindow.vala"
	_g_free0 (_tmp191_);
#line 319 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp192_);
#line 319 "../src/MainWindow.vala"
	button_sin = _tmp192_;
#line 325 "../src/MainWindow.vala"
	_tmp193_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 325 "../src/MainWindow.vala"
	_tmp194_ = g_variant_new_string ("sinh");
#line 325 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp194_);
#line 325 "../src/MainWindow.vala"
	_tmp195_ = g_strdup (_ ("Hyperbolic Sine"));
#line 325 "../src/MainWindow.vala"
	_tmp196_ = pantheon_calculator_button_new ("sinh");
#line 325 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp196_, _tmp193_);
#line 325 "../src/MainWindow.vala"
	_g_free0 (_tmp193_);
#line 325 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp196_, "action-target", _tmp194_, NULL);
#line 325 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp194_);
#line 325 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp196_, _tmp195_);
#line 325 "../src/MainWindow.vala"
	_g_free0 (_tmp195_);
#line 325 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp196_);
#line 325 "../src/MainWindow.vala"
	button_sinh = _tmp196_;
#line 331 "../src/MainWindow.vala"
	_tmp197_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 331 "../src/MainWindow.vala"
	_tmp198_ = g_variant_new_string ("cos");
#line 331 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp198_);
#line 331 "../src/MainWindow.vala"
	_tmp199_ = g_strdup (_ ("Cosine"));
#line 331 "../src/MainWindow.vala"
	_tmp200_ = pantheon_calculator_button_new ("cos");
#line 331 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp200_, _tmp197_);
#line 331 "../src/MainWindow.vala"
	_g_free0 (_tmp197_);
#line 331 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp200_, "action-target", _tmp198_, NULL);
#line 331 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp198_);
#line 331 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp200_, _tmp199_);
#line 331 "../src/MainWindow.vala"
	_g_free0 (_tmp199_);
#line 331 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp200_);
#line 331 "../src/MainWindow.vala"
	button_cos = _tmp200_;
#line 337 "../src/MainWindow.vala"
	_tmp201_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 337 "../src/MainWindow.vala"
	_tmp202_ = g_variant_new_string ("cosh");
#line 337 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp202_);
#line 337 "../src/MainWindow.vala"
	_tmp203_ = g_strdup (_ ("Hyperbolic Cosine"));
#line 337 "../src/MainWindow.vala"
	_tmp204_ = pantheon_calculator_button_new ("cosh");
#line 337 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp204_, _tmp201_);
#line 337 "../src/MainWindow.vala"
	_g_free0 (_tmp201_);
#line 337 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp204_, "action-target", _tmp202_, NULL);
#line 337 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp202_);
#line 337 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp204_, _tmp203_);
#line 337 "../src/MainWindow.vala"
	_g_free0 (_tmp203_);
#line 337 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp204_);
#line 337 "../src/MainWindow.vala"
	button_cosh = _tmp204_;
#line 343 "../src/MainWindow.vala"
	_tmp205_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 343 "../src/MainWindow.vala"
	_tmp206_ = g_variant_new_string ("tan");
#line 343 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp206_);
#line 343 "../src/MainWindow.vala"
	_tmp207_ = g_strdup (_ ("Tangent"));
#line 343 "../src/MainWindow.vala"
	_tmp208_ = pantheon_calculator_button_new ("tan");
#line 343 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp208_, _tmp205_);
#line 343 "../src/MainWindow.vala"
	_g_free0 (_tmp205_);
#line 343 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp208_, "action-target", _tmp206_, NULL);
#line 343 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp206_);
#line 343 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp208_, _tmp207_);
#line 343 "../src/MainWindow.vala"
	_g_free0 (_tmp207_);
#line 343 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp208_);
#line 343 "../src/MainWindow.vala"
	button_tan = _tmp208_;
#line 349 "../src/MainWindow.vala"
	_tmp209_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 349 "../src/MainWindow.vala"
	_tmp210_ = g_variant_new_string ("tanh");
#line 349 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp210_);
#line 349 "../src/MainWindow.vala"
	_tmp211_ = g_strdup (_ ("Hyperbolic Tangent"));
#line 349 "../src/MainWindow.vala"
	_tmp212_ = pantheon_calculator_button_new ("tanh");
#line 349 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp212_, _tmp209_);
#line 349 "../src/MainWindow.vala"
	_g_free0 (_tmp209_);
#line 349 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp212_, "action-target", _tmp210_, NULL);
#line 349 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp210_);
#line 349 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp212_, _tmp211_);
#line 349 "../src/MainWindow.vala"
	_g_free0 (_tmp211_);
#line 349 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp212_);
#line 349 "../src/MainWindow.vala"
	button_tanh = _tmp212_;
#line 355 "../src/MainWindow.vala"
	_tmp213_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 355 "../src/MainWindow.vala"
	_tmp214_ = g_variant_new_string ("π");
#line 355 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp214_);
#line 355 "../src/MainWindow.vala"
	_tmp215_ = g_strdup (_ ("Pi"));
#line 355 "../src/MainWindow.vala"
	_tmp216_ = pantheon_calculator_button_new ("π");
#line 355 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp216_, _tmp213_);
#line 355 "../src/MainWindow.vala"
	_g_free0 (_tmp213_);
#line 355 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp216_, "action-target", _tmp214_, NULL);
#line 355 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp214_);
#line 355 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp216_, _tmp215_);
#line 355 "../src/MainWindow.vala"
	_g_free0 (_tmp215_);
#line 355 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp216_);
#line 355 "../src/MainWindow.vala"
	button_pi = _tmp216_;
#line 361 "../src/MainWindow.vala"
	_tmp217_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_INSERT);
#line 361 "../src/MainWindow.vala"
	_tmp218_ = g_variant_new_string ("e");
#line 361 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp218_);
#line 361 "../src/MainWindow.vala"
	_tmp219_ = g_strdup (_ ("Euler's Number"));
#line 361 "../src/MainWindow.vala"
	_tmp220_ = pantheon_calculator_button_new ("e");
#line 361 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp220_, _tmp217_);
#line 361 "../src/MainWindow.vala"
	_g_free0 (_tmp217_);
#line 361 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp220_, "action-target", _tmp218_, NULL);
#line 361 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp218_);
#line 361 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp220_, _tmp219_);
#line 361 "../src/MainWindow.vala"
	_g_free0 (_tmp219_);
#line 361 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp220_);
#line 361 "../src/MainWindow.vala"
	button_e = _tmp220_;
#line 367 "../src/MainWindow.vala"
	_tmp221_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 367 "../src/MainWindow.vala"
	_tmp222_ = g_variant_new_string ("log");
#line 367 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp222_);
#line 367 "../src/MainWindow.vala"
	_tmp223_ = g_strdup (_ ("Logarithm Base 10"));
#line 367 "../src/MainWindow.vala"
	_tmp224_ = pantheon_calculator_button_new ("log<sub>10</sub>");
#line 367 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp224_, _tmp221_);
#line 367 "../src/MainWindow.vala"
	_g_free0 (_tmp221_);
#line 367 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp224_, "action-target", _tmp222_, NULL);
#line 367 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp222_);
#line 367 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp224_, _tmp223_);
#line 367 "../src/MainWindow.vala"
	_g_free0 (_tmp223_);
#line 367 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp224_);
#line 367 "../src/MainWindow.vala"
	button_log = _tmp224_;
#line 373 "../src/MainWindow.vala"
	_tmp225_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 373 "../src/MainWindow.vala"
	_tmp226_ = g_variant_new_string ("ln");
#line 373 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp226_);
#line 373 "../src/MainWindow.vala"
	_tmp227_ = g_strdup (_ ("Natural Logarithm"));
#line 373 "../src/MainWindow.vala"
	_tmp228_ = pantheon_calculator_button_new ("ln");
#line 373 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp228_, _tmp225_);
#line 373 "../src/MainWindow.vala"
	_g_free0 (_tmp225_);
#line 373 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp228_, "action-target", _tmp226_, NULL);
#line 373 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp226_);
#line 373 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp228_, _tmp227_);
#line 373 "../src/MainWindow.vala"
	_g_free0 (_tmp227_);
#line 373 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp228_);
#line 373 "../src/MainWindow.vala"
	button_ln = _tmp228_;
#line 379 "../src/MainWindow.vala"
	_tmp229_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 379 "../src/MainWindow.vala"
	_tmp230_ = g_variant_new_string ("asin");
#line 379 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp230_);
#line 379 "../src/MainWindow.vala"
	_tmp231_ = g_strdup (_ ("Inverse Sine"));
#line 379 "../src/MainWindow.vala"
	_tmp232_ = pantheon_calculator_button_new ("sin<sup>-1</sup>");
#line 379 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp232_, _tmp229_);
#line 379 "../src/MainWindow.vala"
	_g_free0 (_tmp229_);
#line 379 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp232_, "action-target", _tmp230_, NULL);
#line 379 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp230_);
#line 379 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp232_, _tmp231_);
#line 379 "../src/MainWindow.vala"
	_g_free0 (_tmp231_);
#line 379 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp232_);
#line 379 "../src/MainWindow.vala"
	button_asin = _tmp232_;
#line 385 "../src/MainWindow.vala"
	_tmp233_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 385 "../src/MainWindow.vala"
	_tmp234_ = g_variant_new_string ("acos");
#line 385 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp234_);
#line 385 "../src/MainWindow.vala"
	_tmp235_ = g_strdup (_ ("Inverse Cosine"));
#line 385 "../src/MainWindow.vala"
	_tmp236_ = pantheon_calculator_button_new ("cos<sup>-1</sup>");
#line 385 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp236_, _tmp233_);
#line 385 "../src/MainWindow.vala"
	_g_free0 (_tmp233_);
#line 385 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp236_, "action-target", _tmp234_, NULL);
#line 385 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp234_);
#line 385 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp236_, _tmp235_);
#line 385 "../src/MainWindow.vala"
	_g_free0 (_tmp235_);
#line 385 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp236_);
#line 385 "../src/MainWindow.vala"
	button_acos = _tmp236_;
#line 391 "../src/MainWindow.vala"
	_tmp237_ = g_strdup (PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_PREFIX PANTHEON_CALCULATOR_MAIN_WINDOW_ACTION_FUNCTION);
#line 391 "../src/MainWindow.vala"
	_tmp238_ = g_variant_new_string ("atan");
#line 391 "../src/MainWindow.vala"
	g_variant_ref_sink (_tmp238_);
#line 391 "../src/MainWindow.vala"
	_tmp239_ = g_strdup (_ ("Inverse Tangent"));
#line 391 "../src/MainWindow.vala"
	_tmp240_ = pantheon_calculator_button_new ("tan<sup>-1</sup>");
#line 391 "../src/MainWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp240_, _tmp237_);
#line 391 "../src/MainWindow.vala"
	_g_free0 (_tmp237_);
#line 391 "../src/MainWindow.vala"
	g_object_set ((GtkActionable*) _tmp240_, "action-target", _tmp238_, NULL);
#line 391 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp238_);
#line 391 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp240_, _tmp239_);
#line 391 "../src/MainWindow.vala"
	_g_free0 (_tmp239_);
#line 391 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp240_);
#line 391 "../src/MainWindow.vala"
	button_atan = _tmp240_;
#line 397 "../src/MainWindow.vala"
	_tmp241_ = g_strdup (_ ("Reciprocal"));
#line 397 "../src/MainWindow.vala"
	_tmp242_ = pantheon_calculator_button_new ("x<sup>-1</sup>");
#line 397 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp242_, _tmp241_);
#line 397 "../src/MainWindow.vala"
	_g_free0 (_tmp241_);
#line 397 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp242_);
#line 397 "../src/MainWindow.vala"
	button_reciprocal = _tmp242_;
#line 401 "../src/MainWindow.vala"
	_tmp243_ = (GtkGrid*) gtk_grid_new ();
#line 401 "../src/MainWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp243_, 6);
#line 401 "../src/MainWindow.vala"
	gtk_grid_set_column_spacing (_tmp243_, 6);
#line 401 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp243_, 6);
#line 401 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp243_, GTK_ALIGN_FILL);
#line 401 "../src/MainWindow.vala"
	gtk_grid_set_row_homogeneous (_tmp243_, TRUE);
#line 401 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp243_);
#line 401 "../src/MainWindow.vala"
	extended_grid = _tmp243_;
#line 410 "../src/MainWindow.vala"
	_tmp244_ = extended_grid;
#line 410 "../src/MainWindow.vala"
	_tmp245_ = button_ms;
#line 410 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp244_, (GtkWidget*) _tmp245_, 0, 0, 1, 1);
#line 411 "../src/MainWindow.vala"
	_tmp246_ = extended_grid;
#line 411 "../src/MainWindow.vala"
	_tmp247_ = button_par_left;
#line 411 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp246_, (GtkWidget*) _tmp247_, 1, 0, 1, 1);
#line 412 "../src/MainWindow.vala"
	_tmp248_ = extended_grid;
#line 412 "../src/MainWindow.vala"
	_tmp249_ = button_par_right;
#line 412 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp248_, (GtkWidget*) _tmp249_, 2, 0, 1, 1);
#line 413 "../src/MainWindow.vala"
	_tmp250_ = extended_grid;
#line 413 "../src/MainWindow.vala"
	_tmp251_ = button_log;
#line 413 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp250_, (GtkWidget*) _tmp251_, 3, 0, 1, 1);
#line 415 "../src/MainWindow.vala"
	_tmp252_ = extended_grid;
#line 415 "../src/MainWindow.vala"
	_tmp253_ = self->priv->button_mr;
#line 415 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp252_, (GtkWidget*) _tmp253_, 0, 1, 1, 1);
#line 416 "../src/MainWindow.vala"
	_tmp254_ = extended_grid;
#line 416 "../src/MainWindow.vala"
	_tmp255_ = button_pow;
#line 416 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp254_, (GtkWidget*) _tmp255_, 1, 1, 1, 1);
#line 417 "../src/MainWindow.vala"
	_tmp256_ = extended_grid;
#line 417 "../src/MainWindow.vala"
	_tmp257_ = button_sr;
#line 417 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp256_, (GtkWidget*) _tmp257_, 2, 1, 1, 1);
#line 418 "../src/MainWindow.vala"
	_tmp258_ = extended_grid;
#line 418 "../src/MainWindow.vala"
	_tmp259_ = button_ln;
#line 418 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp258_, (GtkWidget*) _tmp259_, 3, 1, 1, 1);
#line 420 "../src/MainWindow.vala"
	_tmp260_ = extended_grid;
#line 420 "../src/MainWindow.vala"
	_tmp261_ = button_m_add;
#line 420 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp260_, (GtkWidget*) _tmp261_, 0, 2, 1, 1);
#line 421 "../src/MainWindow.vala"
	_tmp262_ = extended_grid;
#line 421 "../src/MainWindow.vala"
	_tmp263_ = button_sin;
#line 421 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp262_, (GtkWidget*) _tmp263_, 1, 2, 1, 1);
#line 422 "../src/MainWindow.vala"
	_tmp264_ = extended_grid;
#line 422 "../src/MainWindow.vala"
	_tmp265_ = button_sinh;
#line 422 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp264_, (GtkWidget*) _tmp265_, 2, 2, 1, 1);
#line 423 "../src/MainWindow.vala"
	_tmp266_ = extended_grid;
#line 423 "../src/MainWindow.vala"
	_tmp267_ = button_asin;
#line 423 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp266_, (GtkWidget*) _tmp267_, 3, 2, 1, 1);
#line 425 "../src/MainWindow.vala"
	_tmp268_ = extended_grid;
#line 425 "../src/MainWindow.vala"
	_tmp269_ = button_m_sub;
#line 425 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp268_, (GtkWidget*) _tmp269_, 0, 3, 1, 1);
#line 426 "../src/MainWindow.vala"
	_tmp270_ = extended_grid;
#line 426 "../src/MainWindow.vala"
	_tmp271_ = button_cos;
#line 426 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp270_, (GtkWidget*) _tmp271_, 1, 3, 1, 1);
#line 427 "../src/MainWindow.vala"
	_tmp272_ = extended_grid;
#line 427 "../src/MainWindow.vala"
	_tmp273_ = button_cosh;
#line 427 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp272_, (GtkWidget*) _tmp273_, 2, 3, 1, 1);
#line 428 "../src/MainWindow.vala"
	_tmp274_ = extended_grid;
#line 428 "../src/MainWindow.vala"
	_tmp275_ = button_acos;
#line 428 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp274_, (GtkWidget*) _tmp275_, 3, 3, 1, 1);
#line 430 "../src/MainWindow.vala"
	_tmp276_ = extended_grid;
#line 430 "../src/MainWindow.vala"
	_tmp277_ = self->priv->button_mc;
#line 430 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp276_, (GtkWidget*) _tmp277_, 0, 4, 1, 1);
#line 431 "../src/MainWindow.vala"
	_tmp278_ = extended_grid;
#line 431 "../src/MainWindow.vala"
	_tmp279_ = button_tan;
#line 431 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp278_, (GtkWidget*) _tmp279_, 1, 4, 1, 1);
#line 432 "../src/MainWindow.vala"
	_tmp280_ = extended_grid;
#line 432 "../src/MainWindow.vala"
	_tmp281_ = button_tanh;
#line 432 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp280_, (GtkWidget*) _tmp281_, 2, 4, 1, 1);
#line 433 "../src/MainWindow.vala"
	_tmp282_ = extended_grid;
#line 433 "../src/MainWindow.vala"
	_tmp283_ = button_atan;
#line 433 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp282_, (GtkWidget*) _tmp283_, 3, 4, 1, 1);
#line 435 "../src/MainWindow.vala"
	_tmp284_ = extended_grid;
#line 435 "../src/MainWindow.vala"
	_tmp285_ = self->priv->button_gt;
#line 435 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp284_, (GtkWidget*) _tmp285_, 0, 5, 1, 1);
#line 436 "../src/MainWindow.vala"
	_tmp286_ = extended_grid;
#line 436 "../src/MainWindow.vala"
	_tmp287_ = button_pi;
#line 436 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp286_, (GtkWidget*) _tmp287_, 1, 5, 1, 1);
#line 437 "../src/MainWindow.vala"
	_tmp288_ = extended_grid;
#line 437 "../src/MainWindow.vala"
	_tmp289_ = button_e;
#line 437 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp288_, (GtkWidget*) _tmp289_, 2, 5, 1, 1);
#line 438 "../src/MainWindow.vala"
	_tmp290_ = extended_grid;
#line 438 "../src/MainWindow.vala"
	_tmp291_ = button_reciprocal;
#line 438 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp290_, (GtkWidget*) _tmp291_, 3, 5, 1, 1);
#line 440 "../src/MainWindow.vala"
	_tmp292_ = extended_grid;
#line 440 "../src/MainWindow.vala"
	_tmp293_ = _g_object_ref0 ((GtkWidget*) _tmp292_);
#line 440 "../src/MainWindow.vala"
	_tmp294_ = (GtkRevealer*) gtk_revealer_new ();
#line 440 "../src/MainWindow.vala"
	gtk_revealer_set_transition_type (_tmp294_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 440 "../src/MainWindow.vala"
	gtk_revealer_set_child (_tmp294_, _tmp293_);
#line 440 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp293_);
#line 440 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp294_);
#line 440 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->extended_revealer);
#line 440 "../src/MainWindow.vala"
	self->priv->extended_revealer = _tmp294_;
#line 445 "../src/MainWindow.vala"
	_tmp295_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 445 "../src/MainWindow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp295_, 6);
#line 445 "../src/MainWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp295_, 6);
#line 445 "../src/MainWindow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp295_, 6);
#line 445 "../src/MainWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp295_, 6);
#line 445 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp295_);
#line 445 "../src/MainWindow.vala"
	main_grid = _tmp295_;
#line 451 "../src/MainWindow.vala"
	_tmp296_ = main_grid;
#line 451 "../src/MainWindow.vala"
	_tmp297_ = basic_grid;
#line 451 "../src/MainWindow.vala"
	gtk_box_append (_tmp296_, (GtkWidget*) _tmp297_);
#line 452 "../src/MainWindow.vala"
	_tmp298_ = main_grid;
#line 452 "../src/MainWindow.vala"
	_tmp299_ = self->priv->extended_revealer;
#line 452 "../src/MainWindow.vala"
	gtk_box_append (_tmp298_, (GtkWidget*) _tmp299_);
#line 454 "../src/MainWindow.vala"
	_tmp300_ = (GtkLabel*) gtk_label_new ("");
#line 454 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp300_);
#line 454 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->infobar_label);
#line 454 "../src/MainWindow.vala"
	self->priv->infobar_label = _tmp300_;
#line 456 "../src/MainWindow.vala"
	_tmp301_ = (GtkInfoBar*) gtk_info_bar_new ();
#line 456 "../src/MainWindow.vala"
	gtk_info_bar_set_message_type (_tmp301_, GTK_MESSAGE_WARNING);
#line 456 "../src/MainWindow.vala"
	gtk_info_bar_set_revealed (_tmp301_, FALSE);
#line 456 "../src/MainWindow.vala"
	gtk_info_bar_set_show_close_button (_tmp301_, FALSE);
#line 456 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp301_);
#line 456 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->infobar);
#line 456 "../src/MainWindow.vala"
	self->priv->infobar = _tmp301_;
#line 461 "../src/MainWindow.vala"
	_tmp302_ = self->priv->infobar;
#line 461 "../src/MainWindow.vala"
	_tmp303_ = self->priv->infobar_label;
#line 461 "../src/MainWindow.vala"
	gtk_info_bar_add_child (_tmp302_, (GtkWidget*) _tmp303_);
#line 463 "../src/MainWindow.vala"
	_tmp304_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 463 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp304_);
#line 463 "../src/MainWindow.vala"
	global_box = _tmp304_;
#line 464 "../src/MainWindow.vala"
	_tmp305_ = global_box;
#line 464 "../src/MainWindow.vala"
	_tmp306_ = self->priv->infobar;
#line 464 "../src/MainWindow.vala"
	gtk_box_append (_tmp305_, (GtkWidget*) _tmp306_);
#line 465 "../src/MainWindow.vala"
	_tmp307_ = global_box;
#line 465 "../src/MainWindow.vala"
	_tmp308_ = main_grid;
#line 465 "../src/MainWindow.vala"
	gtk_box_append (_tmp307_, (GtkWidget*) _tmp308_);
#line 467 "../src/MainWindow.vala"
	_tmp309_ = global_box;
#line 467 "../src/MainWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp309_);
#line 468 "../src/MainWindow.vala"
	_tmp310_ = headerbar;
#line 468 "../src/MainWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp310_);
#line 470 "../src/MainWindow.vala"
	_tmp311_ = self->priv->entry;
#line 470 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp311_);
#line 472 "../src/MainWindow.vala"
	_tmp312_ = self->priv->entry;
#line 472 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp312_, "changed", (GCallback) _pantheon_calculator_main_window_remove_error_gtk_editable_changed, self, 0);
#line 473 "../src/MainWindow.vala"
	_tmp313_ = self->priv->entry;
#line 473 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp313_, "activate", (GCallback) _pantheon_calculator_main_window_button_calc_clicked_gtk_entry_activate, self, 0);
#line 474 "../src/MainWindow.vala"
	_tmp314_ = self->priv->entry;
#line 474 "../src/MainWindow.vala"
	_tmp315_ = gtk_editable_get_delegate ((GtkEditable*) _tmp314_);
#line 474 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp315_, "insert-text", (GCallback) _pantheon_calculator_main_window_replace_text_gtk_editable_insert_text, self, 0);
#line 476 "../src/MainWindow.vala"
	_tmp316_ = self->priv->button_calc;
#line 476 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp316_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda38__gtk_button_clicked, self, 0);
#line 477 "../src/MainWindow.vala"
	_tmp317_ = self->priv->button_del;
#line 477 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp317_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda39__gtk_button_clicked, self, 0);
#line 478 "../src/MainWindow.vala"
	_tmp318_ = self->priv->button_ans;
#line 478 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp318_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda40__gtk_button_clicked, self, 0);
#line 480 "../src/MainWindow.vala"
	_tmp319_ = self->priv->button_mr;
#line 480 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp319_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda41__gtk_button_clicked, self, 0);
#line 484 "../src/MainWindow.vala"
	_tmp320_ = button_ms;
#line 484 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp320_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda42__gtk_button_clicked, self, 0);
#line 485 "../src/MainWindow.vala"
	_tmp321_ = button_m_add;
#line 485 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp321_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda43__gtk_button_clicked, self, 0);
#line 486 "../src/MainWindow.vala"
	_tmp322_ = button_m_sub;
#line 486 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp322_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda44__gtk_button_clicked, self, 0);
#line 487 "../src/MainWindow.vala"
	_tmp323_ = self->priv->button_mc;
#line 487 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp323_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda45__gtk_button_clicked, self, 0);
#line 488 "../src/MainWindow.vala"
	_tmp324_ = self->priv->button_gt;
#line 488 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp324_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda46__gtk_button_clicked, self, 0);
#line 489 "../src/MainWindow.vala"
	_tmp325_ = button_reciprocal;
#line 489 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp325_, "clicked", (GCallback) __pantheon_calculator_main_window___lambda47__gtk_button_clicked, self, 0);
#line 491 "../src/MainWindow.vala"
	_tmp326_ = pantheon_calculator_main_window_settings;
#line 491 "../src/MainWindow.vala"
	_tmp327_ = self->priv->button_extended;
#line 491 "../src/MainWindow.vala"
	g_settings_bind (_tmp326_, "extended-shown", (GObject*) _tmp327_, "active", G_SETTINGS_BIND_DEFAULT | G_SETTINGS_BIND_GET_NO_CHANGES);
#line 495 "../src/MainWindow.vala"
	_tmp328_ = application_instance;
#line 495 "../src/MainWindow.vala"
	_tmp329_ = gtk_application_get_windows (_tmp328_);
#line 495 "../src/MainWindow.vala"
	if (g_list_length (_tmp329_) == ((guint) 0)) {
#line 5526 "MainWindow.c"
		GSettings* privacy_settings = NULL;
		GSettings* _tmp330_;
		GSettings* _tmp331_;
#line 497 "../src/MainWindow.vala"
		_tmp330_ = g_settings_new ("org.gnome.desktop.privacy");
#line 497 "../src/MainWindow.vala"
		privacy_settings = _tmp330_;
#line 498 "../src/MainWindow.vala"
		_tmp331_ = privacy_settings;
#line 498 "../src/MainWindow.vala"
		if (g_settings_get_boolean (_tmp331_, "remember-recent-files")) {
#line 5538 "MainWindow.c"
			GSettings* _tmp332_;
			GtkEntry* _tmp333_;
#line 499 "../src/MainWindow.vala"
			_tmp332_ = pantheon_calculator_main_window_settings;
#line 499 "../src/MainWindow.vala"
			_tmp333_ = self->priv->entry;
#line 499 "../src/MainWindow.vala"
			g_settings_bind (_tmp332_, "entry-content", (GObject*) _tmp333_, "text", G_SETTINGS_BIND_DEFAULT);
#line 5547 "MainWindow.c"
		}
#line 495 "../src/MainWindow.vala"
		_g_object_unref0 (privacy_settings);
#line 5551 "MainWindow.c"
	}
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (global_box);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (main_grid);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (extended_grid);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_reciprocal);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_atan);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_acos);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_asin);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_ln);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_log);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_e);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_pi);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_tanh);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_tan);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_cosh);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_cos);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_sinh);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_sin);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_sr);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_pow);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_par_right);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_par_left);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_m_sub);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_m_add);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_ms);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (basic_grid);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_9);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_8);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_7);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_6);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_5);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_4);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_3);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_2);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_1);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_percent);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_point);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_0);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_div);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_mult);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_sub);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_add);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (button_clr);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (headerbar);
#line 75 "../src/MainWindow.vala"
	_g_object_unref0 (application_instance);
#line 75 "../src/MainWindow.vala"
	return obj;
#line 5643 "MainWindow.c"
}

static void
pantheon_calculator_main_window_class_init (PantheonCalculatorMainWindowClass * klass,
                                            gpointer klass_data)
{
	GSettings* _tmp0_;
#line 21 "../src/MainWindow.vala"
	pantheon_calculator_main_window_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &PantheonCalculatorMainWindow_private_offset);
#line 21 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = pantheon_calculator_main_window_constructor;
#line 21 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = pantheon_calculator_main_window_finalize;
#line 68 "../src/MainWindow.vala"
	_tmp0_ = g_settings_new ("io.elementary.calculator.saved-state");
#line 68 "../src/MainWindow.vala"
	_g_object_unref0 (pantheon_calculator_main_window_settings);
#line 68 "../src/MainWindow.vala"
	pantheon_calculator_main_window_settings = _tmp0_;
#line 5665 "MainWindow.c"
}

static void
pantheon_calculator_main_window_instance_init (PantheonCalculatorMainWindow * self,
                                               gpointer klass)
{
#line 21 "../src/MainWindow.vala"
	self->priv = pantheon_calculator_main_window_get_instance_private (self);
#line 48 "../src/MainWindow.vala"
	self->priv->memory_value = (gdouble) 0;
#line 5676 "MainWindow.c"
}

static void
pantheon_calculator_main_window_finalize (GObject * obj)
{
	PantheonCalculatorMainWindow * self;
#line 21 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_CALCULATOR_TYPE_MAIN_WINDOW, PantheonCalculatorMainWindow);
#line 24 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->extended_revealer);
#line 25 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->entry);
#line 26 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_calc);
#line 27 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_history);
#line 28 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_ans);
#line 29 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_del);
#line 30 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_mr);
#line 31 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_mc);
#line 32 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_gt);
#line 33 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->button_extended);
#line 34 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->history_dialog);
#line 36 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->infobar);
#line 37 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->infobar_label);
#line 39 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->eval);
#line 41 "../src/MainWindow.vala"
	(self->priv->history == NULL) ? NULL : (self->priv->history = (_g_list_free__pantheon_calculator_main_window_history_free0_ (self->priv->history), NULL));
#line 21 "../src/MainWindow.vala"
	G_OBJECT_CLASS (pantheon_calculator_main_window_parent_class)->finalize (obj);
#line 5717 "MainWindow.c"
}

static GType
pantheon_calculator_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonCalculatorMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_calculator_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonCalculatorMainWindow), 0, (GInstanceInitFunc) pantheon_calculator_main_window_instance_init, NULL };
	GType pantheon_calculator_main_window_type_id;
	pantheon_calculator_main_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PantheonCalculatorMainWindow", &g_define_type_info, 0);
	PantheonCalculatorMainWindow_private_offset = g_type_add_instance_private (pantheon_calculator_main_window_type_id, sizeof (PantheonCalculatorMainWindowPrivate));
	return pantheon_calculator_main_window_type_id;
}

GType
pantheon_calculator_main_window_get_type (void)
{
	static volatile gsize pantheon_calculator_main_window_type_id__once = 0;
	if (g_once_init_enter (&pantheon_calculator_main_window_type_id__once)) {
		GType pantheon_calculator_main_window_type_id;
		pantheon_calculator_main_window_type_id = pantheon_calculator_main_window_get_type_once ();
		g_once_init_leave (&pantheon_calculator_main_window_type_id__once, pantheon_calculator_main_window_type_id);
	}
	return pantheon_calculator_main_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

